MODULE Console;

IMPORT
  Windows, SysUtils, SYSTEM;

VAR  
  hin, hout: Windows.HANDLE;

PROCEDURE Length*(str:ARRAY OF CHAR): LONGINT;
VAR
  n,i,c:LONGINT;
BEGIN
  n:=LEN(str);
  i:=0;
  WHILE (i<n) & (str[i]>0X) DO INC(i); END;
  RETURN i;
END Length;

PROCEDURE WriteString*(str:ARRAY OF CHAR);
VAR
  n,i,c:LONGINT;
BEGIN
  n:=Length(str);
  i:=0;

  WHILE (i<n) DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c-64;
    ELSIF (c>=240) & (c<=255) THEN c:=c-16;
    ELSIF (c=168)             THEN c:=240;
    ELSIF (c=184)             THEN c:=241;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

  SYSTEM.PUTREG(0, Windows.WriteFile(hout, str, n, n, NIL));
END WriteString;

PROCEDURE Write*(ch: CHAR);
VAR
  str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := ch;
  str[1] := 0X;
  WriteString(str);
END Write;

PROCEDURE WriteIntTab*(x, n: LONGINT);
VAR
  i, x0: LONGINT;
a: ARRAY 10 OF CHAR;
BEGIN
  i := 0;

IF x < 0 THEN
	IF x = MIN(LONGINT) THEN
      WriteString(" -2147483648");
      RETURN
	ELSE
      DEC(n);
      x0 := -x
	END
ELSE
    x0 := x
END;

  REPEAT
	a[i] := CHR(x0 MOD 10 + 30H);
    x0 := x0 DIV 10;
    INC(i)
  UNTIL x0 = 0;

  WHILE n > i DO
    Write(" ");
    DEC(n);
  END;

  IF x < 0 THEN Write("-") END;
  REPEAT DEC(i);
    Write(a[i]);
  UNTIL i = 0;

END WriteIntTab;

PROCEDURE WriteInt*(x: LONGINT);
BEGIN
  WriteString(SysUtils.IntToStr(x));
END WriteInt;

PROCEDURE WriteReal*(x: LONGREAL);
BEGIN
  WriteString(SysUtils.RealToStr(x));
END WriteReal;

PROCEDURE WriteBool*(x: BOOLEAN);
BEGIN
  WriteString(SysUtils.BoolToStr(x));
END WriteBool;

PROCEDURE WriteSet*(x: SET);
BEGIN
  WriteString(SysUtils.SetToStr(x));
END WriteSet;

PROCEDURE WriteLn*();
VAR
  str: ARRAY 2 OF CHAR;
BEGIN
  str[0] := 0DX;
  str[1] := 0AX;
  WriteString(str);
END WriteLn;

PROCEDURE ReadString*(VAR str:ARRAY OF CHAR);
VAR
  n,i,c:LONGINT;
BEGIN
  n:=LEN(str);
  i:=0;
  SYSTEM.PUTREG(0, Windows.ReadFile(hin, str, n, n, NIL));
  str[n-2]:=0X; (* - 0AX 0DX *)
  
  WHILE i<n DO
    c:=ORD(str[i]);
    IF    (c>=192) & (c<=239) THEN c:=c+16;
    ELSIF (c=240)             THEN c:=168;
    ELSIF (c=241)             THEN c:=184;
    ELSIF (c=168)             THEN c:=232;
    END;
    str[i]:=CHR(c);
    INC(i);
  END;

END ReadString;

BEGIN
  hin := Windows.GetStdHandle(Windows.STD_INPUT_HANDLE);
  hout:= Windows.GetStdHandle(Windows.STD_OUTPUT_HANDLE);
END Console.
