unit FindFrm;

interface

uses
  Windows, Forms, Graphics, GlowControls, Controls,
  Classes, StdCtrls, Dialogs, ComCtrls;

type
  TFindForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure ButtonClick(Sender: TObject);
    function  CreateButton(lpCaption: String; uLeft,uTop,uTag: integer): integer;
  public
    { Public declarations }
  end;

var
  FindForm: TFindForm;

implementation

uses
  MainFrm;

{$R *.dfm}

procedure TFindForm.ButtonClick(Sender: TObject);
begin
  Close;
  MainForm.Memo.fWord:=Edit1.Text;
  MainForm.Memo.FindWord(0,MainForm.Memo.Range.PosY,True,True);
end;

function TFindForm.CreateButton(lpCaption: String; uLeft,uTop,uTag: integer): integer;
var
  Button: TShButton;
begin
  Button:= TShButton.Create(Self);
  with Button do begin
    Parent        := Self;
    Caption       := lpCaption;
    Font.Color    := $00608E9C;
    Width         := 75;
    Height        := 22;
    Left          := uLeft;
    Top           := uTop;
    ShowFocusRect := false;
    OnClick       := ButtonClick;
    Tag           := uTag;
    with Colors do begin
      DefaultFrom := clCream;
      DefaultTo   := $00A7CDD5;
      ClickedFrom := $00C4E2E7;
      ClickedTo   := clWhite;
      BorderColor := $00608E9C;
      OverFrom    := clWhite;
      OverTo      := $00C4E2E7;
    end;
  end;
  Result:=uLeft;
end;

procedure TFindForm.FormCreate(Sender: TObject);
begin
  CreateButton('Find',Width-85,ClientHeight-28,0);
end;

procedure TFindForm.FormShow(Sender: TObject);
begin
  Edit1.Text:=MainForm.Memo.Range.Text;
end;

end.
