unit InspectFrm;

interface

uses
  Forms, Classes, Controls, Graphics, SPageControl, ObjInspector, StdCtrls,
  ExtCtrls, TypInfo, SysUtils, Dialogs;

type
  TInspectPanel = class(TForm)
    ComboBox1: TComboBox;
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ObjectInspector: TComponentInspector;
  end;

var
  InspectPanel: TInspectPanel;

implementation

uses
  MainFrm;

{$R *.dfm}

procedure TInspectPanel.FormCreate(Sender: TObject);
var
  Pages   : TSPageControl;
  Page    : TSTabSheet;
begin

  Pages:=TSPageControl.Create(Self);
  with Pages do begin
    Parent                := Self;
    Align                 := alClient;
    RoundEdges            := true;
    LowerActive           := 0;
    AlignWithMargins      := true;
    Margins.Top:=0;
    TabBackGroundColor    := Self.Color;
    TabBorderColor        := clMedGray;
    ActiveColor           := clWhite;
    ActiveFont.Color      := clMaroon;
    TabStyle              := tsDotNet;
    DefaultTabColor       := clWhite;
    TabSheetBorderColor   := clMedGray;
  end;

  Page                    := TSTabSheet.Create(Pages);
  Page.SPageControl       := Pages;
  Page.Color              := clWhite;
  Pages.ActivePage        := Page;
  Page.OnMouseUp          := FormMouseUp;
  Page.Caption            := ' Properties ';

  ObjectInspector:=TComponentInspector.Create(Self);
  with ObjectInspector do begin
    Parent:=Page;
    Align:=alClient;
    BorderStyle:=bsNone;
    Mode:=imProperties;
    Instance:=NIL;
    ShowHint:=true;
    //OnGetButtonType := GetButtonType;
    //OnGetValuesList := GetValuesList;
    //OnChangeValue:=ChangeValue;
  end;

  Page                    := TSTabSheet.Create(Pages);
  Page.SPageControl       := Pages;
  Page.Color              := clWhite;
  Page.OnMouseUp          := FormMouseUp;
  Page.Caption            := 'Events ';

end;

procedure TInspectPanel.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Self.SetFocus;
end;

end.
