unit MainFrm;

interface

uses  
  Windows, Forms, ExtCtrls, DockTabSet, Controls, Classes, Tabs, StdCtrls, Menus,
  SysUtils, Graphics, SPageControl, ComCtrls, SynEdit, MessagesFrm, IniFiles, PathUtils,
  Dialogs, ToolWin, ActnMan, ActnCtrls, ActnMenus, XPStyleActnCtrls, ActnList, CommCtrl,
  StdStyleActnCtrls, ActnColorMaps, Messages, GlowControls, ManagerFrm, Clipbrd,
  ImgList, ActnPopup, Buttons, ObrHighliter, OBRParser, Compiler, FindFrm;

type
  TDTabSheet = class(TSTabSheet)
  public
    SelectNode  : TTreeNode;
    Instance    : TComponent;
    Path        : String;
    InProject   : boolean;    
  end;

  TMemoInfo = class(TComponent)
  private
    fName,fPath: String;
    fTag: integer;
    procedure SetName(const Value: String); reintroduce;
    procedure SetPath(const Value: String);
  published
    property Name: String read fName write SetName;
    property Path: String read fPath write SetPath;
    property Tag : integer read fTag;
  end;

  TMainForm = class(TForm)
    MainPanel: TPanel;
    DockTabSet1: TDockTabSet; 
    LeftPanel: TPanel;
    Splitter1: TSplitter;
    ChildPanel: TPanel;     
    BottomPanel: TPanel;
    Splitter2: TSplitter;
    DockTabSet3: TDockTabSet;    
    Container: TPanel;
    RightPanel: TPanel;
    Splitter3: TSplitter;
    Content: TPanel;
    StatusBar1: TStatusBar;
    ActionMainMenuBar1: TActionMainMenuBar;
    ActionManager1: TActionManager;
    XPColorMap1: TXPColorMap;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    PopUp: TPopupActionBar;
    CloseWindow: TMenuItem;
    ForPopup: TImageList;
    ForMenu: TImageList;
    ActOpen: TAction;
    ActOpenPrj: TAction;
    ActReopen: TAction;
    ActSave: TAction;
    ActSaveAs: TAction;
    ActSavePrjAs: TAction;
    ActSaveAll: TAction;
    ActClose: TAction;
    ActCloseAll: TAction;
    ActObrPrj: TAction;
    ActObrMod: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ActExit: TAction;
    ActPrjOpt: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ActCompile: TAction;
    ToolButton12: TToolButton;
    ActSavePrj: TAction;
    SetMainMod: TMenuItem;
    UnSetMainMod: TMenuItem;
    N1: TMenuItem;
    MemoMenuPopup: TPopupActionBar;
    Undo1: TMenuItem;
    N2: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Selectall1: TMenuItem;
    Closepage1: TMenuItem;
    ActUndo: TAction;
    ActCut: TAction;
    ActCopy: TAction;
    ActPaste: TAction;
    ActDel: TAction;
    ActSelectAll: TAction;
    ActClosePage: TAction;
    ToolButton13: TToolButton;
    ActCompileRun: TAction;
    ActFind: TAction;
    Find1: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    CopyasHTML: TMenuItem;
    N4: TMenuItem;
    ActHTML: TAction;
    ActRTF: TAction;
    CopyasRTF1: TMenuItem;
    ActOptions: TAction;
    ToolButton16: TToolButton;
    ActCompilLink: TAction;
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DockTabSetDockDrop(Sender: TObject; Source: TDragDockObject; X,Y: Integer);
    procedure DockTabSetTabRemoved(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure DockTabSetUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure PanelDockDrop(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer);
    procedure PanelDockOver(Sender: TObject; Source: TDragDockObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure CheckPanel(Sender: TObject);
    procedure PanelMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ActEmptyPrjExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CloseWindowClick(Sender: TObject);
    procedure ActOpenExecute(Sender: TObject);
    procedure ActObrModExecute(Sender: TObject);
    procedure ActSaveExecute(Sender: TObject);
    procedure ActSaveAsExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActSaveAllExecute(Sender: TObject);
    procedure ActExitExecute(Sender: TObject);
    procedure ActCloseAllExecute(Sender: TObject);
    procedure ActPrjOptExecute(Sender: TObject);
    procedure ActCompileExecute(Sender: TObject);
    procedure ActSavePrjAsExecute(Sender: TObject);
    procedure ActSavePrjExecute(Sender: TObject);
    procedure SetMainModClick(Sender: TObject);
    procedure UnSetMainModClick(Sender: TObject);
    procedure MemoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PopUpGetControlClass(Sender: TCustomActionBar;
      AnItem: TActionClient; var ControlClass: TCustomActionControlClass);
    procedure MemoWordInfo(Sender: TCustomSyntaxMemo; const X, Y, WordIndex, Row: Integer; Showing: Boolean);
    procedure ActUndoExecute(Sender: TObject);
    procedure ActCutExecute(Sender: TObject);
    procedure ActPasteExecute(Sender: TObject);
    procedure ActDelExecute(Sender: TObject);
    procedure ActSelectAllExecute(Sender: TObject);
    procedure ActClosePageExecute(Sender: TObject);
    procedure ActCopyExecute(Sender: TObject);
    procedure ActCompileRunExecute(Sender: TObject);
    procedure ActFindExecute(Sender: TObject);
    procedure ActHTMLExecute(Sender: TObject);
    procedure ActRTFExecute(Sender: TObject);
    procedure ActOptionsExecute(Sender: TObject);
    procedure ActCompilLinkExecute(Sender: TObject);
  protected
    procedure UpdateActions; override;
  private
    { Private declarations }
    fLoadForm           : boolean;
    fMemo               : TSyntaxMemo;
    fMouseDown          : boolean;
    function  GetMemo   : TSyntaxMemo;
    procedure NewProject;
    procedure PagesMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
    procedure PagesDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PagesDragOver(Sender, Source: TObject; X, Y: Integer;State: TDragState; var Accept: Boolean);
    procedure MemoChange(Sender: TObject; ChangedItems: TChangedItems);
    procedure PageChange(Sender: TObject);
  public
    { Public declarations }
    ShowButton  : TShButton;
    fPages      : TSPageControl;
    Page        : TDTabSheet;
    SubText,SubHex, SubView: TDTabSheet;
    fMemoInfo   : TMemoInfo;
    function  FindMemo(M: String): TSyntaxMemo;
    function  FindPage(C: String): TDTabSheet;
    procedure OpenProject(Name: string);
    procedure OpenFile(InPrj: boolean);
    procedure SaveMod(Root: TTreeNode; Ini: TIniFile; var C: integer);
    procedure CreateIni(Path: String; Root: TTreeNode);
    function  SaveProjectAs(Root: TTreeNode): boolean;
    function  SaveProject(Root: TTreeNode; Flag: boolean): boolean;
    function  SaveAs: Boolean;
    function  SaveFile: Boolean;
    function  SaveMemo(M: TCustomSyntaxMemo): Boolean;
    function  SaveAll: Boolean;
    function  CloseFile: Boolean;
    function  CloseAll: Boolean;
    procedure NewPage(Path: String; Typ: TFileType; InPrj: boolean);
    procedure SetPage(Name: String; Node: TTreeNode);
  published
    property Memo     : TSyntaxMemo read GetMemo write fMemo;
  end;

var
  MainForm : TMainForm;
  MainMenu : TMainMenu;

implementation

uses
  ToolFrm, StructFrm, InspectFrm, DebugFrm, OptionsFrm, OPM;

{$R *.dfm}

procedure TMainForm.DockTabSetTabRemoved(Sender: TObject);
begin
  with (Sender as TDockTabSet) do Visible := Tabs.Count > 0;
end;

procedure TMainForm.DockTabSetUnDock(Sender: TObject; Client: TControl;
  NewTarget: TWinControl; var Allow: Boolean);
begin
  case (Sender as TDockTabSet).Tag of
    0:
      begin
        if NewTarget.Width=0 then NewTarget.Width:=200;
        Splitter1.Left:=NewTarget.Width;
        Splitter1.Visible:=true;
      end;
    1:
      begin
        if NewTarget.Width=0 then NewTarget.Width:=200;
        Splitter3.Left:=Container.Width-NewTarget.Width;
        Splitter3.Visible:=true;
      end;
  end;
  CheckPanel(NewTarget);
end;

procedure TMainForm.DockTabSetDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
begin
  (Sender as TDockTabSet).Visible:=true;
end;

procedure TMainForm.CheckPanel(Sender: TObject);
var
  i,n: integer;
begin
  n:=0;
  for i:=0 to (Sender as TPanel).DockClientCount-1 do
    if not (Sender as TPanel).DockClients[i].Visible then Inc(n); 
  if (n=(Sender as TPanel).DockClientCount)
  or ((Sender as TPanel).DockClientCount=1)
  or ((Sender as TPanel).DockClientCount=0) then begin
    case (Sender as TPanel).Tag of
      0:Splitter1.Visible := False;
      1:Splitter3.Visible := False;
      2:
        begin
          Splitter2.Visible := False;
          (Sender as TPanel).Height:=0;
        end;
    end;
    (Sender as TPanel).Width:=0;
  end;
end;

procedure TMainForm.PanelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  CheckPanel(Sender);
end;

procedure TMainForm.PanelUnDock(Sender: TObject; Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
begin
  CheckPanel(Sender);
end;

procedure TMainForm.PanelDockDrop(Sender: TObject; Source: TDragDockObject;X, Y: Integer);
begin
  with (Sender as TPanel) do
    case (Sender as TPanel).Tag of
      0,1:  if Width = 0  then Width := 200;
      2:    if Height = 0 then Height := 100;
    end;

  case (Sender as TPanel).Tag of
    0:
    begin
      Splitter1.Visible := True;
      Splitter1.Left := Width;
    end;
    1:
    begin
      Splitter3.Visible := True;
      Splitter3.Left:=Container.Width-(Sender as TPanel).Width;
    end;
    2:Splitter2.Visible := True;
  end;
end;

procedure TMainForm.PanelDockOver(Sender: TObject; Source: TDragDockObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
var
  R: TRect;
begin
  Accept := Source.Control is TObject;
  if Accept then begin
    with (Sender as TPanel) do begin
      case Tag of
        0:
          begin
            R.TopLeft := (Sender as TPanel).ClientToScreen(Point(0, 0));
            R.BottomRight := (Sender as TPanel).ClientToScreen(Point(200, Height));
          end;
        1:
          begin
            R.TopLeft := (Sender as TPanel).ClientToScreen(Point(0, 0));
            R.BottomRight := (Sender as TPanel).ClientToScreen(Point(200, Height));
            if (Sender as TPanel).Width=0 then
              R.BottomRight := MainPanel.ClientToScreen(Point(MainPanel.Width-200, Height));
          end;
        2:
          begin
            R.BottomRight := (Sender as TPanel).ClientToScreen(Point(0,Height-100));
            R.TopLeft := (Sender as TPanel).ClientToScreen(Point(Width, Height));
          end;
      end;
      Source.DockRect := R;
    end;
  end;

end;

procedure TMainForm.PopUpGetControlClass(Sender: TCustomActionBar;
  AnItem: TActionClient; var ControlClass: TCustomActionControlClass);
begin
  if Assigned(PopUp.PopupMenu) then
    PopUp.PopupMenu.ColorMap:= XPColorMap1;
  if Assigned(MemoMenuPopup.PopupMenu) then
    MemoMenuPopup.PopupMenu.ColorMap:= XPColorMap1;
end;

//#######################################################################

procedure TMemoInfo.SetName(const Value: String);
begin
  if fName <> Value then fName := Value;
end;

procedure TMemoInfo.SetPath(const Value: String);
begin
  if fPath <> Value then fPath := Value;
end;

//#######################################################################

procedure TMainForm.FormCreate(Sender: TObject);
begin
  fPages:=TSPageControl.Create(Self);
  with fPages do begin
    Parent:=Content;
    Align:=alClient;
    TabBackGroundColor:=$00ddf2f5;//$00ebfafc;
    AlignWithMargins:=true;
    Margins.Bottom:=3;
    Margins.left:=0;
    Margins.Right:=0;
    Margins.Top:=0;
    TabBackGround.LoadFromResourceName(0,'TABOFF');
    TabBackGroundActive.LoadFromResourceName(0,'TABON');
    Images:=ForMenu;
    TabOverlap:=9;
    RoundEdges:=true;
    LowerActive:=0;
    TabHeight:=19;
    TabWidth:=0;
    TabMargin.LeftMargin:=2;
    TabMargin.TopMargin:=1;
    TabMargin.RightMargin  := 5;
    TabSheetBorderColor:=clMedGray;
    OnMouseDown:=PagesMouseDown;
    OnDragDrop:=PagesDragDrop;
    OnDragOver:=PagesDragOver;
    OnChange := PageChange;
  end;
  DoubleBuffered:=true;
  ToolBar.DoubleBuffered:=true;

  fMemoInfo   := TMemoInfo.Create(Self);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var
  i: integer;
  SubPage : TSPageControl;
begin
  for i:=0 to fPages.PageCount-1 do begin
    SubPage  := TSPageControl(fPages.Pages[i].Controls[0]);
    TCustomSyntaxMemo(SubPage.Pages[0].Controls[0]).Free;
    SubPage.Free;
  end;
  MainMenu.Free;
  fMemoInfo.Free;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  if not fLoadForm then begin
    ToolPanel.ManualDock   (RightPanel,NIL,alTop);
    //RightPanel.Padding.Top:=300;
    //RightPanel.Padding.Bottom:=300;
    ManagerPanel.ManualDock(RightPanel,NIL,alTop);
    RightPanel.Padding.Top:=0;
    RightPanel.Padding.Bottom:=0;
    InspectPanel.ManualDock(LeftPanel, NIL,alTop);
    StructPanel.ManualDock (LeftPanel, NIL,alTop);
    fLoadForm:=true;
  end;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Application.CreateForm(TToolPanel,ToolPanel);
  ToolPanel.ManualDock(RightPanel);
  Application.CreateForm(TManagerPanel,ManagerPanel);
  ManagerPanel.ManualDock(RightPanel);
  Application.CreateForm(TInspectPanel,InspectPanel);
  InspectPanel.ManualDock(LeftPanel);
  Application.CreateForm(TStructPanel,StructPanel);
  StructPanel.ManualDock(LeftPanel);
  Application.CreateForm(TDebugPanel,DebugPanel);
  DebugPanel.ManualDock(BottomPanel);

  ManagerPanel.Show;   
  ToolPanel.Show;
  StructPanel.Show;
  InspectPanel.Show;
  DebugPanel.Show;

  DebugPanel.ManualDock(BottomPanel,NIL,alClient);
end;

function TMainForm.FindMemo(M: String): TSyntaxMemo;
var
  i: integer;
  SubPage : TSPageControl;
begin
  Result:=NIL;
  if fPages.PageCount<=0 then Exit;
  for i:=fPages.PageCount-1 downto 0 do
    if SameText(TDTabSheet(fPages.Pages[i]).Caption,M) then begin
      SubPage  := TSPageControl(fPages.Pages[i].Controls[0]);
      Result:=TSyntaxMemo(SubPage.Pages[0].Controls[0]);
      Exit;
    end;
end;

function TMainForm.GetMemo: TSyntaxMemo;
var
  SubPage : TSPageControl;
begin
  Result:=NIL;
  if fPages.PageCount<=0 then Exit;
  SubPage  := TSPageControl(fPages.Pages[fPages.ActivePageIndex].Controls[0]);
  Result   := TSyntaxMemo(SubPage.Pages[0].Controls[0]);
  fMemoInfo.Path:=Result.Path;
  fMemoInfo.Name:=Result.Name;
end;

procedure TMainForm.SetMainModClick(Sender: TObject);
begin
  if ManagerPanel.TreeView.Items.Count=0 then Exit;
  ManagerPanel.SetMain(QuickSearch(ManagerPanel.TreeView.Items.Item[0],fPages.Pages[fPages.ActivePageIndex].Caption),true);
  ManagerPanel.SetModified(true);
end;

procedure TMainForm.UnSetMainModClick(Sender: TObject);
begin
  if ManagerPanel.TreeView.Items.Count=0 then Exit;
  ManagerPanel.SetMain(QuickSearch(ManagerPanel.TreeView.Items.Item[0],fPages.Pages[fPages.ActivePageIndex].Caption),false);
  ManagerPanel.SetModified(true);
end;

procedure TMainForm.SetPage(Name: String; Node: TTreeNode);
var
  i: integer;
begin
  if fPages.PageCount<=0 then begin
    NewPage(TFileHead(Node.Data).Path+Name,TFileHead(Node.Data).Types,true);
    Exit;
  end;
  i:=0;
  while (fPages.Pages[i].Caption<>Name) and (i<fPages.PageCount-1) do Inc(i);
  if fPages.Pages[i].Caption=Name then begin
    fPages.ActivePage:=fPages.Pages[i];
    if TDTabSheet(fPages.ActivePage).SelectNode=NIL then ManagerPanel.TreeView.Selected:=Node;
  end else
    NewPage(TFileHead(Node.Data).Path+Name,TFileHead(Node.Data).Types,true);
  Memo.SetFocus;
  InspectPanel.ObjectInspector.Instance:=fMemoInfo;
  OBRManage(fPages.ActivePage.Caption,StructPanel.TreeView,Memo.Lines);
end;

procedure TMainForm.MemoChange(Sender: TObject; ChangedItems: TChangedItems);
var
  Mdf: String;
begin
  StatusBar1.Panels[0].Text:=IntToStr(Memo.Range.PosY+1)+':'+IntToStr(Memo.Range.PosX+1);
  Mdf:='';
  if Memo.Lines.Modified then Mdf:=' Modified';
  StatusBar1.Panels[2].Text:=Mdf;
end;

procedure TMainForm.PageChange(Sender: TObject);
var
  Node: TTreeNode;
begin
  OBRManage(fPages.ActivePage.Caption,StructPanel.TreeView,Memo.Lines);
  if not TDTabSheet(fPages.ActivePage).InProject then begin
    Memo.SetFocus;
    InspectPanel.ObjectInspector.Instance:=fMemoInfo;
    Exit;
  end;
  if fPages.PageCount=0 then begin
    ManagerPanel.TreeView.Selected:=ManagerPanel.TreeView.Items[0];
    Exit;
  end;
  if TDTabSheet(fPages.ActivePage).SelectNode<>NIL then
    ManagerPanel.TreeView.Selected:=TDTabSheet(fPages.ActivePage).SelectNode
  else begin
    Node:=QuickSearch(ManagerPanel.TreeView.Items[0],fPages.ActivePage.Caption);
    ManagerPanel.TreeView.Selected:=Node;
  end;
  Memo.SetFocus;
  InspectPanel.ObjectInspector.Instance:=fMemoInfo;
end;

procedure TMainForm.PagesDragDrop(Sender, Source: TObject; X, Y: Integer);
const
  TCM_GETITEMRECT = $130A;
var
  i: Integer;
  r: TRect;
begin
  if not (Sender is TSPageControl) then Exit;
  with fPages do begin
    for i := 0 to PageCount - 1 do begin
      Perform(TCM_GETITEMRECT, i, lParam(@r));
      if PtInRect(r, Point(X, Y)) then
      begin
        if i <> ActivePage.PageIndex then
        ActivePage.PageIndex := i;
        Exit;
      end;
    end;
  end;
end;

procedure TMainForm.PagesDragOver(Sender, Source: TObject; X,Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Sender is TSPageControl then Accept := True;
end;

procedure TMainForm.PagesMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  P: TPoint;
  HitTestInfo : TTCHitTestInfo;
  HitIndex : Integer;
begin
  fPages.BeginDrag(False);
  if Button=mbRight then begin
    HitTestInfo.pt.x := X;
    HitTestInfo.pt.y := Y;
    HitTestInfo.flags := 0;
    HitIndex := SendMessage(fPages.Handle, TCM_HITTEST, 0, Longint(@HitTestInfo));
    fPages.ActivePage:=fPages.Pages[HitIndex];
    PageChange(Self);
    GetCursorPos(P);
    fPages.Pages[fPages.ActivePageIndex].PopupMenu:=PopUp;

    with PopUp do
      if (ManagerPanel.TreeView.Items.Count>0)
      and TFileHead(ManagerPanel.TreeView.Selected.Data).Main then begin
        Items[2].ImageIndex:=8;
        Items[2].Enabled:=false;
        Items[3].Enabled:=true;
      end else begin
        Items[2].ImageIndex:=-1;
        Items[2].Enabled:=ManagerPanel.TreeView.Items.Count>0;
        Items[3].Enabled:=false;
      end;

    fPages.Pages[fPages.ActivePageIndex].PopupMenu.Popup(P.X,P.Y);
    fPages.Pages[fPages.ActivePageIndex].PopupMenu:=nil;
  end;
end;

function TMainForm.FindPage(C: String): TDTabSheet;
var
  i: integer;
begin
  Result:=NIL;
  for i:=fPages.PageCount-1 downto 0 do
    if SameText(TDTabSheet(fPages.Pages[i]).Caption,C) then begin
      Result:=TDTabSheet(fPages.Pages[i]);
      Exit;
    end;
end;

//#####################################################################

procedure TMainForm.OpenFile(InPrj: boolean);
var
  i: integer;
begin
  with OpenDialog1 do begin
    Filter:='';
    Filter := 'Oberon files(*'+OPM.projectext+';*'+OPM.moduleext+')|*'+OPM.projectext+';*'+OPM.moduleext+'';
    FilterIndex := 0;
    if Execute then begin
      if SameText(ExtractFileExt(OpenDialog1.FileName),OPM.projectext) then
        OpenProject(OpenDialog1.FileName)
      else if InPrj then begin
        for i:=0 to OpenDialog1.Files.count-1 do
          ManagerPanel.AddModFile(OpenDialog1.Files[i],i=0,-1);
          ManagerPanel.SetModified(true);
      end else begin
        for i:=0 to OpenDialog1.Files.count-1 do
          NewPage(OpenDialog1.Files[i],_ModFile,InPrj);
      end;
    end;
  end;
end;

function TMainForm.SaveAs: Boolean;
var
  Path,Name,Ext,_E,_Ex: String;
  fType: TFileType;
  Node: TTreeNode;
  P: integer;
begin
  Node:=NIL;
  if ManagerPanel.TreeView.Items.Count>0 then
    Node:=QuickSearch(ManagerPanel.TreeView.Items[0],fPages.ActivePage.Caption);
  fType:=FindType(fPages.ActivePage.Caption);
  case fType of
    _ModFile: begin _E:='Oberon compiler (*'+OPM.moduleext+')|*'+OPM.moduleext+''; _Ex :=OPM.moduleext; end;
  else
    _E:='Oberon compiler (*'+OPM.moduleext+')|*'+OPM.moduleext;
    _Ex       :=OPM.moduleext;
  end;
  SaveDialog1.Filter := 'Files '+_E+'|TXT files (*.txt)|*.txt|All files (*.*)|*.*';
  SaveDialog1.FilterIndex := 0;
  SaveDialog1.FileName:=fPages.ActivePage.Caption;
  Result := SaveDialog1.Execute;
  if Result then begin
    Path:=ExtractFilePath(SaveDialog1.FileName);
    Ext := ExtractFileExt(SaveDialog1.FileName);
    Name:=ExtractFileName(SaveDialog1.FileName);

    if ManagerPanel.TreeView.Items.Count>0 then
      if QuickSearch(ManagerPanel.TreeView.Items[0],Name)<>NIL then
        if Name<>fPages.ActivePage.Caption then begin
          MessagesFrm.MsgBox.MessageForm('File name "'+Name+'" of a file exists!',
                                        'Error !!!', MB_ICONQUESTION,MB_OK);
          Exit;
        end;
    
    P:=Pos(Ext,Name)-1;
    if P>0 then Name:=Copy(Name,1,P);
    if Ext='' then Ext:=_Ex;
    Memo.Lines.SaveToFile(Path+Name+Ext);
    if Node<>NIL then begin
      DeleteNode(Node);
      ManagerPanel.AddModFile(Path+Name+Ext,false,-1);
    end;
    Memo.Lines.Modified:=false;
    Memo.Name:=Name+Ext;
    Memo.Path:=Path;
    fPages.Pages[fPages.ActivePageIndex].Caption:=Name+Ext;
    OBRManage(Name+Ext,StructPanel.TreeView,Memo.Lines);
  end;
end;

function TMainForm.SaveFile: Boolean;
begin
  Result := (Memo.Path<>'');
  if not Result then begin
    Result := SaveAs;
  end else begin
    Memo.Lines.SaveToFile(Memo.Path+Memo.Name);
    Memo.Lines.Modified:=false;
  end;
end;

function TMainForm.SaveMemo(M: TCustomSyntaxMemo): Boolean;
begin
  Result := (M.Path<>'');
  if not Result then begin
    Result := SaveAs;
  end else begin
    M.Lines.SaveToFile(M.Path+M.Name);
    M.Lines.Modified:=false;
  end;
end;

function TMainForm.SaveAll: Boolean;
var
  i: Integer;
  SubPage: TSPageControl;
  M:TCustomSyntaxMemo;
begin
  Result := False;
  if fPages.PageCount<=0 then Exit;
  for i:=fPages.PageCount-1 downto 0 do begin
    SubPage  := TSPageControl(fPages.Pages[i].Controls[0]);
    M:=TCustomSyntaxMemo(SubPage.Pages[0].Controls[0]);
    if not SaveMemo(M) then Exit;
  end;
  Result := True;
end;

function TMainForm.CloseFile: Boolean;
var
  Node: TTreeNode;
  Msg : integer;
begin
  Result := not Memo.Lines.Modified;
  Msg:=mrCancel;
  Node:=NIL;
  if not Result then begin
    Msg:=MessagesFrm.MsgBox.MessageForm('Save in "'+fPages.Pages[fPages.ActivePageIndex].Caption+'" ?',
                                       'Warning !!!',MB_ICONQUESTION,MB_YESNOCANCEL);
    case Msg of
      mrYes:      Result := SaveFile;
      mrNo:       Result := True;
      mrCancel:   Result := False;
    end;
  end;
  if Result then begin
    if ManagerPanel.TreeView.Items.Count>0 then
      Node:=QuickSearch(ManagerPanel.TreeView.Items[0],fPages.ActivePage.Caption);
    if (Msg=mrNo) and (Memo.Path='') and (Node<>NIL) then DeleteNode(Node);
    fPages.ActivePage.Destroy;
    if fPages.PageCount>0 then PageChange(Self);
  end;
  if fPages.PageCount<=0 then begin
    StructPanel.TreeView.Items.Clear;
    StructPanel.TreeView.Visible:=false;
  end;
  if ManagerPanel.TreeView.Items.Count=1 then begin
    FreeNode(ManagerPanel.TreeView.Items.Item[0]);
    TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Free;
    ManagerPanel.TreeView.Items.Clear;
    ManagerPanel.TreeView.Visible:=false;
  end;
end;

function TMainForm.CloseAll: Boolean;
var
  i:integer;
begin
  Result := False;
  for i:=fPages.PageCount-1 downto 0 do begin
    if not CloseFile then Exit;
  end;
  if ActSavePrj.Enabled and (ManagerPanel.TreeView.Items.Count>0) then
    SaveProject(ManagerPanel.TreeView.Items.Item[0],false);
  Result := True;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := CloseAll;
end;

procedure TMainForm.MemoMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  P: TPoint;
begin
  if Button=mbRight then begin
    GetCursorPos(P);
    fPages.Pages[fPages.ActivePageIndex].PopupMenu:=MemoMenuPopup;
    fPages.Pages[fPages.ActivePageIndex].PopupMenu.Popup(P.X,P.Y);
    fPages.Pages[fPages.ActivePageIndex].PopupMenu:=nil;
  end;
  if Button=mbLeft then
    if ssCtrl in Shift then fMouseDown:=true;
end;

procedure TMainForm.MemoWordInfo(Sender: TCustomSyntaxMemo;const X, Y, WordIndex, Row: Integer; Showing: Boolean);
var
  S,T,TS: String;
  i: integer;
begin
  if Showing and fMouseDown then begin
    with Memo.Lines.Parser[Row].Tokens[WordIndex] do begin
    
      S := Copy(Memo.Lines[Row], stStart + 1, stLength);

      if S<>'SYSTEM' then begin
        i:=0;
        if WordIndex>1 then begin
          i:=WordIndex-1;
          with Memo.Lines.Parser[Row].Tokens[i] do
            TS:=Copy(Memo.Lines[Row], stStart + 1, stLength);
          if TS='.' then begin
            repeat
              DEC(i);
              with Memo.Lines.Parser[Row].Tokens[i] do
                Ts:=Copy(Memo.Lines[Row], stStart + 1, stLength);
              if i<=0 then BREAK;
              DEC(i);
              with Memo.Lines.Parser[Row].Tokens[i] do
                T:=Copy(Memo.Lines[Row], stStart + 1, stLength);
            until (T<>'.') OR (i<0);
          end else
            TS:=S;
        end else
          TS:=S;

        INC(i);

        if i<Memo.Lines.Parser[Row].Count then
          with Memo.Lines.Parser[Row].Tokens[i+1] do begin
            T:=Copy(Memo.Lines[Row], stStart + 1, stLength);
            if T='.' then begin
              if ManagerPanel.TreeView.Items.Count>0 then begin
                MainFrm.MainForm.NewPage(TS+OPM.moduleext,_ModFile,(QuickSearch(ManagerPanel.TreeView.Items.Item[0],TS+OPM.moduleext)<>NIL))
              end else
                MainFrm.MainForm.NewPage(TS+OPM.moduleext,_ModFile,false);
            end;
          end;
            
      end;

      Memo.fWord:=S;
      Memo.FindWord(0,0,True,True);

    end;
    //DebugPanel.AddMsg(S,5,NIL);
    fMouseDown:=false;
  end;
end;

//#####################################################################

procedure TMainForm.OpenProject(Name: string);
var
  Ini: TIniFile;
  FName: String;
  Count,i,n: integer;
begin
  CloseAll;
  if ManagerPanel.TreeView.Items.Count>0 then begin
    if ManagerPanel.GetModified then SaveProject(ManagerPanel.TreeView.Items.Item[0],false);
    FreeNode(ManagerPanel.TreeView.Items.Item[0]);
    TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Free;
    ManagerPanel.TreeView.Items.Clear;
  end; 
  Ini:=TIniFile.Create(Name);
  FName:=Ini.ReadString('Project','ProjectName','');
  ManagerPanel.SetNewProject(ExtractFilePath(Name)+FName);
  TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Path:=ExtractFilePath(Name);
  TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Search:=ExtractFilePath(Name);

  n:=Ini.ReadInteger('Project','MainModule',0);

  Count:=Ini.ReadInteger('Project','FileCount',0);
  for i:=1 to Count do begin
    FName:=Ini.ReadString('Files','Module'+IntToStr(i),'');
    FName:=RelativePathToAbsolute(ExtractFilePath(Name),FName);
    ManagerPanel.AddModFile(FName,i=n,n);
    if (n=0) and (i=Count) then NewPage(FName,_ModFile,true);
  end;
  Ini.Free;
end;

procedure TMainForm.SaveMod(Root: TTreeNode; Ini: TIniFile; var C: integer);
var
  i: integer;
begin
  with Root do
    for i:=Count-1 downto 0 do begin
      if Item[i].Count>0 then SaveMod(Item[i],Ini,C);
      if TFileHead(Item[i].Data).Types<>_Nil then begin
        if TFileHead(Item[i].Data).Main then Ini.WriteInteger('Project','MainModule',C+1);
        Ini.WriteString('Files','Module'+IntToStr(C+1),AbsolutePathToRelative(TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Path, TFileHead(Item[i].Data).Path+TFileHead(Item[i].Data).Name));
        Inc(C);
      end;
    end;
end;

procedure TMainForm.CreateIni(Path: String; Root: TTreeNode);
var
  Count: integer;
  Ini: TIniFile;
begin
  Ini:= TIniFile.Create(Path);
  Ini.EraseSection('Project');
  Ini.EraseSection('Files');
  Ini.WriteString('Project','ProjectName',ExtractFileName(Path));
  Ini.WriteInteger('Project','MainModule',0);
  Count:=0;
  SaveMod(Root,Ini,Count);
  Ini.WriteInteger('Project','FileCount',Count);
  Ini.Free;
end;

function TMainForm.SaveProjectAs(Root: TTreeNode): boolean;
begin
  Result:=SaveAll;
  SaveDialog1.Filter := 'All files (*.*)|*.*';
  SaveDialog1.FilterIndex := 0;
  SaveDialog1.FileName:=TFileHead(Root.Data).Path+TFileHead(Root.Data).Name;
  if SaveDialog1.Execute then begin
    TFileHead(Root.Data).Path:=ExtractFilePath(SaveDialog1.FileName);
    TFileHead(Root.Data).Name:=ExtractFileName(SaveDialog1.FileName);
    TFileHead(Root.Data).Search:=TFileHead(Root.Data).Path;
    ManagerPanel.SetModified(false);
    ManagerPanel.TreeView.Items.Item[0].Text:=TFileHead(Root.Data).Name;
    CreateIni(TFileHead(Root.Data).Path+TFileHead(Root.Data).Name,Root);
    Result:=true;
  end;
end;

function TMainForm.SaveProject(Root: TTreeNode; Flag: boolean): boolean;
var
  Msg: integer;
begin
  Result:=TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Path<>'';
  if not Result then begin
    Result := SaveProjectAs(Root);
  end else begin
    Result := SaveAll;

    if Flag then
      Result:=True
    else if TFileHead(Root.Data).Modified then begin
      Msg:=MessagesFrm.MsgBox.MessageForm('Save in "'+ManagerPanel.TreeView.Items.Item[0].Text+'" ?',
                                         'Warning !!!',MB_ICONQUESTION,MB_YESNOCANCEL);
      case Msg of
        mrYes:      Result := True;
        mrNo:       Result := False;
        mrCancel:   Result := False;
      end;
    end;

    if Result then begin
      CreateIni(TFileHead(Root.Data).Path+TFileHead(Root.Data).Name,Root);
      ManagerPanel.SetModified(false);
    end;
  end;
end;

//#####################################################################

procedure TMainForm.NewProject;
begin
  ManagerPanel.SetNewProject('Project.opr');
end;

procedure TMainForm.ActObrModExecute(Sender: TObject);
begin
  if not ManagerPanel.NewCreated then NewProject;
  ManagerPanel.ModItemClick(Sender);
  ManagerPanel.SetModified(true);
end;

procedure TMainForm.NewPage(Path: String; Typ: TFileType; InPrj: boolean);
var
  P        : TSPageControl;
  Ext,Name : String;
  Active   : TDTabSheet;
  Loaded   : boolean;
begin
  Loaded:=false;
  Name := ExtractFileName(Path);
  
  Active:=FindPage(Name);
  if Active<>NIL then begin
    fPages.ActivePage:=Active;
    PageChange(Self);
    Exit;
  end;

  Page                    := TDTabSheet.Create(fPages);
  Page.Caption            := Name;
  Ext                     := ExtractFileExt(Path);
  Page.ImageIndex         := 30+FindFormat(Ext);
  Page.SPageControl       := fPages;
  Page.Color              := clWhite;
  fPages.ActivePage       := Page;
  Page.SelectNode         := NIL;
  Page.Instance           := NIL;

  P:=TSPageControl.Create(Page);
  with P do begin
    Parent                := Page;
    Align                 := alClient;
    TabPosition           := tpBottom;
    RoundEdges            := true;
    LowerActive           := 0;
    TabHeight             := 19;
    TabWidth              := 0;
    TabBorderColor        := clSilver;
    ActiveColor           := clWhite;
    ActiveFont.Color      := clMaroon;
    TabStyle              := tsDotNet;
    DefaultTabColor       := clWhite;
    TabSheetBorderColor   := clSilver;
    TabBackGroundColor    := clWhite;
    TabMargin.LeftMargin  := 5;
    TabMargin.RightMargin := 5;
    TabWidth              := 50;
    TabHeight             := 16;
  end;

  SubText                 := TDTabSheet.Create(P);
  SubText.Parent          := P;
  SubText.SPageControl    := P;
  SubText.Color           := clWhite;
  SubText.Path            := ExtractFilePath(Path);
  SubText.Caption         := '  Text';
  SubText.TextColor       := clGray;
  SubText.InProject       := InPrj;
  fMemo                   := TSyntaxMemo.Create(Self);
  fMemo.Parent            := SubText;
  fMemo.Align             := alClient;
  fMemo.OnChange          := MemoChange;
  fMemo.OnMouseDown       := MemoMouseDown;
  fMemo.OnWordInfo        := MemoWordInfo;
  
  if Typ=_ModFile then begin
    fMemo.Highliter:=TOBRHighliter.Create(fMemo);
    P.ActivePage := SubText;
    if FileExists(Path) then begin
      fMemo.Lines.BeginUpdate;
      fMemo.Lines.LoadFromUFile(Path);
      fMemo.Lines.EndUpdate;
      fMemo.Lines.Modified:=false;
      fMemo.SetFocus;
      Loaded:=true;
    end;
    fMemo.Path:=ExtractFilePath(Path);
    if (fMemo.Path='') and (ManagerPanel.TreeView.Items.Count>0) then
      fMemo.Path:=TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Path;
    fMemo.Name:=Name;

    fMemoInfo.Path:=fMemo.Path;
    fMemoInfo.Name:=fMemo.Name;
    InspectPanel.ObjectInspector.Instance:=fMemoInfo;

    if not Loaded then OBRParser.AddTemplate(fMemo.Lines,Name);
  end;

  TDTabSheet(fPages.ActivePage).InProject:=InPrj;

  if InPrj then
    PageChange(Self)
  else if Typ=_ModFile then
    OBRManage(fPages.ActivePage.Caption,StructPanel.TreeView,Memo.Lines);
    (*
    Clipboard.Open;
    Clipboard.Clear;
    Clipboard.Close;
    *)
end;

//####################################################################

procedure TMainForm.UpdateActions;
var
  i       : Integer;
  Flag    : Boolean;
  SubPage : TSPageControl;
  Node    : TTreeNode;

  function ClipboardIsEmpty(): Boolean;
  begin
    OpenClipboard(0);
    try
      Result := CountClipboardFormats()=0;
    finally
      CloseClipboard();
    end;
  end;

begin
  inherited;
  //      ,    
  Flag := False;

  if fPages.PageCount<=0 then begin
    StatusBar1.Panels[0].Text:='';
    StatusBar1.Panels[1].Text:='';
    StatusBar1.Panels[2].Text:='';
  end;

  for i:=fPages.PageCount-1 downto 0 do begin
    SubPage  := TSPageControl(fPages.Pages[i].Controls[0]);
    if TCustomSyntaxMemo(SubPage.Pages[0].Controls[0]).Lines.Modified then begin
      Flag := True;
      Break;
    end;
  end;

  ActSaveAll.Enabled  := Flag and (fPages.PageCount>0);
  ActSavePrjAs.Enabled:= StructPanel.TreeView.Items.Count>0;
  ActSavePrj.Enabled  := false;

  if ManagerPanel.TreeView.Items.Count>0 then
    ActSavePrj.Enabled  := Flag or (TFileHead(ManagerPanel.TreeView.Items.Item[0].Data).Modified=true);

  //  
  Flag                := (Memo <> nil) and (fPages.PageCount>0);
  ActSave.Enabled     := Flag and Memo.Lines.Modified;
  ActSaveAs.Enabled   := Flag;
  ActClose.Enabled    := Flag;
  ActCloseAll.Enabled := Flag and (fPages.PageCount>1);
  ActCompile.Enabled  := False;

  //     
  if fPages.PageCount>0 then Flag:=fPages.PageCount>0;

  ActCompile.Enabled    := Flag;
  ActCompilLink.Enabled := Flag;
  ActCompileRun.Enabled := False;
  if ManagerPanel.TreeView.Items.Count>0 then begin
    Node:=QuickSearch(ManagerPanel.TreeView.Items.Item[0],Memo.Name);
    if Node<>NIL then ActCompileRun.Enabled := TFileHead(Node.Data).Main;
  end;

  ActFind.Enabled       := Flag;
  ActUndo.Enabled       := Flag and Memo.Range.CanUndo;
  ActCut.Enabled        := Flag and not Memo.Range.IsEmpty;
  ActPaste.Enabled      := Flag and not ClipboardIsEmpty and (Clipboard.HasFormat(CF_TEXT)<>false){and (ClipBoard.FormatCount=4)};

  ActCopy.Enabled       := Flag and not Memo.Range.IsEmpty;
  ActHTML.Enabled       := Flag and not Memo.Range.IsEmpty;
  ActRTF.Enabled        := Flag and not Memo.Range.IsEmpty;
  ActDel.Enabled        := Flag and not Memo.Range.IsEmpty;
  ActSelectAll.Enabled  := Flag;
  ActClosePage.Enabled  := Flag;

  //ActOptions.Enabled  := ManagerPanel.TreeView.Visible;
  ActPrjOpt.Enabled  := ManagerPanel.TreeView.Visible;
end;

//####################################################################

procedure TMainForm.ActOpenExecute(Sender: TObject);     begin OpenFile(false);       end;
procedure TMainForm.ActOptionsExecute(Sender: TObject);  begin OptionsForm.ShowModal; end;

procedure TMainForm.CloseWindowClick(Sender: TObject);   begin CloseFile;             end;

procedure TMainForm.ActEmptyPrjExecute(Sender: TObject); begin NewProject;            end;
procedure TMainForm.ActSaveExecute(Sender: TObject);     begin SaveFile;              end;
procedure TMainForm.ActSavePrjAsExecute(Sender: TObject);begin SaveProjectAs(ManagerPanel.TreeView.Items.Item[0]);  end;
procedure TMainForm.ActSavePrjExecute(Sender: TObject);  begin SaveProject(ManagerPanel.TreeView.Items.Item[0],true);    end;

procedure TMainForm.ActSaveAsExecute(Sender: TObject);   begin SaveAs;                end;
procedure TMainForm.ActSaveAllExecute(Sender: TObject);  begin
  if ManagerPanel.TreeView.Items.Count>0 then
    SaveProject(ManagerPanel.TreeView.Items.Item[0],true)
  else
    SaveAll;
end;

procedure TMainForm.ActExitExecute(Sender: TObject);     begin Close;                 end;
procedure TMainForm.ActFindExecute(Sender: TObject);     begin FindFrm.FindForm.Show; end;

procedure TMainForm.ActHTMLExecute(Sender: TObject);     begin Memo.Range.CopyAsHTML;  end;
procedure TMainForm.ActRTFExecute(Sender: TObject);      begin Memo.Range.CopyAsHTML;  end;

procedure TMainForm.ActCloseAllExecute(Sender: TObject); begin CloseAll;              end;
procedure TMainForm.ActPrjOptExecute(Sender: TObject);   begin PrjOptionsForm.ShowModal; end;
procedure TMainForm.ActCompileExecute(Sender: TObject);  begin Compiler.Compile(Memo.Name,false,false); end;
procedure TMainForm.ActCompileRunExecute(Sender: TObject);begin Compiler.Compile(Memo.Name,true,true); end;
procedure TMainForm.ActCompilLinkExecute(Sender: TObject);begin Compiler.Compile(Memo.Name,true,false); end;

procedure TMainForm.ActUndoExecute(Sender: TObject);     begin Memo.Range.DoUndo; end;
procedure TMainForm.ActCopyExecute(Sender: TObject);     begin Memo.Range.CopyToClipBoard; end;
procedure TMainForm.ActCutExecute(Sender: TObject);      begin Memo.Range.CutToClipBoard; end;
procedure TMainForm.ActPasteExecute(Sender: TObject);    begin Memo.Range.PasteFromClipBoard; end;

procedure TMainForm.ActDelExecute(Sender: TObject);      begin Memo.Range.Delete; end;
procedure TMainForm.ActSelectAllExecute(Sender: TObject);begin Memo.Range.SelectAll; end;
procedure TMainForm.ActClosePageExecute(Sender: TObject);begin CloseFile; end;

end.
