unit MessagesFrm;

interface

uses
  Windows, Forms, GlowControls, Graphics, Classes, Controls, ExtCtrls;

type
  TMsgBox = class(TForm)
  private
    { Private declarations }
    fBtnResult: integer;
    fimgBitmap: TImage;
    fText     : string;
    procedure ButtonClick(Sender: TObject);
    function  CreateButton(lpCaption: String; uLeft,uTop,uTag: integer): integer;
  protected
    procedure Paint; override;
  public
    { Public declarations }
    function  MessageForm(lpText, lpCaption: String; uIcon,uType: integer): integer;
  end;

var
  MsgBox: TMsgBox;

implementation

{$R *.dfm}
{$R *.res}

procedure TMsgBox.ButtonClick(Sender: TObject);
begin
  case TShButton(Sender).Tag of
    0: fBtnResult:= mrOk;
    1: fBtnResult:= mrYes;
    2: fBtnResult:= mrNo;
    3: fBtnResult:= mrCancel;
  end;
  Close;
end;

function TMsgBox.CreateButton(lpCaption: String; uLeft,uTop,uTag: integer): integer;
var
  Button: TShButton;
begin
  Button:= TShButton.Create(Self);
  with Button do begin
    Parent        := Self;
    Caption       := lpCaption;
    Font.Color    := $00608E9C;
    Width         := 75;
    Height        := 22;
    Left          := uLeft;
    Top           := uTop;
    ShowFocusRect := false;
    OnClick       := ButtonClick;
    Tag           := uTag;
    with Colors do begin
      DefaultFrom := clCream;
      DefaultTo   := $00A7CDD5;
      ClickedFrom := $00C4E2E7;
      ClickedTo   := clWhite;
      BorderColor := $00608E9C;
      OverFrom    := clWhite;
      OverTo      := $00C4E2E7;
    end;
  end;
  Result:=uLeft;
end;

function TMsgBox.MessageForm(lpText, lpCaption: String; uIcon,uType: integer): integer;
var
  Pos, BtnWidth: integer;
begin
  while MsgBox.ComponentCount<>0 do MsgBox.Components[MsgBox.ComponentCount-1].Free;
  MsgBox.Caption:=lpCaption;

  fimgBitmap:= TImage.Create(Self);
  fimgBitmap.Parent:=Self;

  BtnWidth:=77;

  case uType of
    MB_OK         : CreateButton('OK',(Self.ClientWidth-BtnWidth) div 2,Self.ClientHeight-28,0);
    MB_YESNOCANCEL:
                    begin
                      Pos:=CreateButton('No',(Self.ClientWidth-75) div 2,Self.ClientHeight-28,2);
                      CreateButton('Yes',Pos-BtnWidth,Self.ClientHeight-28,1);
                      CreateButton('Cansel',Pos+BtnWidth,Self.ClientHeight-28,3);
                    end;
  end;

  case uIcon of
    MB_ICONEXCLAMATION  : fimgBitmap.Picture.Icon.Handle:=LoadIcon(hInstance, 'MBWARN');
    MB_ICONQUESTION     : fimgBitmap.Picture.Icon.Handle:=LoadIcon(hInstance, 'MBINFO');
  end;

  fimgBitmap.Width:=fimgBitmap.Picture.Icon.Width;
  fimgBitmap.Height:=fimgBitmap.Picture.Icon.Height;
  fimgBitmap.Left:=15;
  fimgBitmap.Top:=((Self.ClientHeight-28)-fimgBitmap.Height) div 2;

  fText:=lpText;

  MsgBox.ShowModal;
  Result:=fBtnResult;
  fimgBitmap.Free;
  fText:='';
end;

procedure TMsgBox.Paint;
begin
  with Canvas do begin
    FillRect(ClipRect);
    TextOut(((Self.Width+fimgBitmap.Width-TextWidth(fText)) div 2),(Self.ClientHeight-28) div 2-8,fText);
  end;
end;

end.
