unit StructFrm;

interface

uses
  Forms, Windows, Classes, Controls, STreeView, ComCtrls;

type
  TStructMode = (smNormal,smResource);
  TStructPanel = class(TForm)
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TreeView  : TSTreeView;
  end;

var
  StructPanel: TStructPanel;

implementation

{$R *.dfm}

procedure FreeNode(Node: TTreeNode);
var
  i: integer;
begin
  with Node do
    for i:=Count-1 downto 0 do begin
      if Item[i].Count>0 then FreeNode(Item[i]);
      Item[i].DeleteChildren;
      TObject(Item[i].Data).Free;
    end;
end;

procedure DeleteNode(Node: TTreeNode);
begin
  FreeNode(Node);
  TObject(Node.Data).Free;
  Node.Delete;
end;

procedure TStructPanel.FormCreate(Sender: TObject);
begin
  TreeView                   := TSTreeView.Create(Self);
  TreeView.Parent            := Self;
  TreeView.DeltaX            := 17;
  TreeView.BorderStyle       := bsNone;
  TreeView.Visible           := false;
  TreeView.DoubleBuffered    := true;
  TreeView.ReadOnly          := true;
end;

procedure TStructPanel.FormDestroy(Sender: TObject);
begin
  if not Assigned(TreeView) or (TreeView.Items.Count=0) then Exit;
  FreeNode(TreeView.Items.Item[0]);
end;

procedure TStructPanel.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetFocus;
end;

procedure TStructPanel.FormResize(Sender: TObject);
begin
  TreeView.Top    := 0;
  TreeView.Left   := -TreeView.DeltaX;
  TreeView.Width  := Width+TreeView.DeltaX;
  TreeView.Height := Height;
end;

end.
