UNIT OPB;

INTERFACE

USES
  _SYSTEM, OPT, OPS, OPV, OPM, SysUtils;

CONST
  AwaitIF     = FALSE;
  AssertTrap  = 8;

VAR
  verify: PROCEDURE(VAR obj: Objects);
  Vverify: BOOLEAN;
  maxExp: LONGINT;
  exp   : INTEGER;
  InitPar: Objects;

  PROCEDURE Field(VAR x: OPT.Nodes; y: OPT.Objects);
  FUNCTION  NewIntConst(intval: LONGINT): OPT.Nodes;
  PROCEDURE Op(op: SHORTINT; VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE FNIn(VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE TypTest(VAR x: OPT.Nodes; obj: OPT.Objects; guard: BOOLEAN);
  PROCEDURE MOp(op: SHORTINT; VAR x: OPT.Nodes);
  FUNCTION  NewLeaf(obj: OPT.Objects): OPT.Nodes;
  PROCEDURE PrepCall(VAR x: OPT.Nodes; VAR fpar: OPT.Objects);
  PROCEDURE Call(VAR x: OPT.Nodes; apar: OPT.Nodes; fp: OPT.Objects);
  FUNCTION  NewRealConst(realval: DOUBLE; typ: OPT.Structs): OPT.Nodes;
  FUNCTION  BoolConst(value: INTEGER): OPT.Nodes;
  FUNCTION  NewString(VAR str: STRING; len: LONGINT): OPT.Nodes;
  FUNCTION  FNNil(): OPT.Nodes;
  PROCEDURE SetRange(VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE SetElem(VAR x: OPT.Nodes);
  FUNCTION  EmptySet(): OPT.Nodes;
  PROCEDURE DeRef(VAR x: OPT.Nodes);
  PROCEDURE Link(VAR x, last: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE StPar0(VAR par0: OPT.Nodes; fctno: INTEGER);
  PROCEDURE StFct(VAR par0: OPT.Nodes; fctno: SHORTINT; parno: INTEGER);
  PROCEDURE Index(VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE StaticLink(dlev: SHORTINT);
  PROCEDURE StPar1(VAR par0: OPT.Nodes; x: OPT.Nodes; fctno: SHORTINT);
  PROCEDURE StParN(VAR par0: OPT.Nodes; x: OPT.Nodes; fctno, n: INTEGER);
  FUNCTION  NewBoolConst(boolval: BOOLEAN): OPT.Nodes;
  PROCEDURE CheckParameters(fp, ap: OPT.Objects; checkNames: BOOLEAN);
  PROCEDURE Assign(VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE CodeInsert(VAR stat: OPT.Nodes);
  PROCEDURE Enter(VAR procdec: OPT.Nodes; stat: OPT.Nodes; proc: OPT.Objects);
  PROCEDURE Inittd(VAR inittd, last: OPT.Nodes; typ: OPT.Structs);
  PROCEDURE FNParam(VAR ap: OPT.Nodes; fp: OPT.Objects);
  PROCEDURE Construct(Aclass: SHORTINT; VAR x: OPT.Nodes;  y: OPT.Nodes);
  PROCEDURE CopyAndSubst(VAR new: OPT.Nodes; old: OPT.Nodes);
  PROCEDURE OptIf(VAR x: OPT.Nodes);
  PROCEDURE Return(VAR x: OPT.Nodes; proc: OPT.Objects);
  PROCEDURE Lock(VAR x: OPT.Nodes; self: OPT.Objects; excl: BOOLEAN);
  PROCEDURE OPBBegin;

IMPLEMENTATION

PROCEDURE InitInsert(VAR stat: OPT.Nodes);
VAR
  t: OPT.Nodes;
BEGIN
  IF OPT.topScope.code=NIL THEN
    OPT.topScope.code:=stat
  ELSE BEGIN
    t:=OPT.topScope.code;
    WHILE t.link<>NIL DO t:=t.link;
    t.link:=stat;
    stat.link:=NIL
  END
END;
	
PROCEDURE CodeInsert(VAR stat: OPT.Nodes);
VAR
  t: OPT.Nodes;
BEGIN
  IF OPT.topScope.link.code=NIL THEN
    OPT.topScope.link.code:=stat
  ELSE BEGIN
    t:=OPT.topScope.link.code;
    WHILE t.link<>NIL DO t:=t.link;
    t.link:=stat;
    stat.link:=NIL
  END
END;

PROCEDURE InitAppend(VAR x: OPT.Nodes);
VAR
  t: OPT.Nodes;
BEGIN (* smistare il contenuto -> per Head forse non necessario *)
  t:=OPT.topScope.code;
  IF t<>NIL THEN BEGIN
    WHILE t.link<>NIL DO t:=t.link;
    t.link:=x;
    x:=OPT.topScope.code;
    OPT.topScope.code:=NIL
  END
END;
	
FUNCTION NewLeaf(obj: OPT.Objects): OPT.Nodes;
VAR
  node: OPT.Nodes;
  self: OPT.Objects;
BEGIN
  IF Vverify THEN BEGIN
    verify(obj);
    Vverify:=TRUE;
  END;
  node:=NIL;
  self:=NIL;
  CASE obj.mode OF
    omVar:
              BEGIN
                node := OPT.NewNode(Nvar);
                node.readonly := ((obj.vis = externalR) AND (obj.mnolev < 0)) OR (obj.vis = internalR);
              END;
    omVarPar:
              BEGIN
                node := OPT.NewNode(Nvarpar);
              END;
    omCon:
              BEGIN
                node := OPT.NewNode(Nconst);
                node.conval := OPT.NewConst();
                node.conval^ := obj.conval^	(* string is not copied, only its ref *)
              END;
    omTyp:            node := OPT.NewNode(Ntype);
    omLProc..omIProc: node := OPT.NewNode(Nproc);
    omFld, omTProc:
              BEGIN
                OPT.FindInScope('@SELF', OPT.topScope, self);
                node := NewLeaf(self);
                Field(node, obj);
                RESULT:= node;
                EXIT;
              END;
  ELSE
    err(127);
    node := OPT.NewNode(Nvar);
  END ;
  node.obj := obj;
  node.typ := obj.typ;
  RESULT:= node;
END;
	
PROCEDURE Construct(Aclass: SHORTINT; VAR x: OPT.Nodes;  y: OPT.Nodes);
VAR
  node: OPT.Nodes;
BEGIN
  node := OPT.NewNode(Aclass);
  node.typ := OPT.notyp;
  node.left := x;
  node.right := y;
  x := node
END;
	
PROCEDURE Link(VAR x, last: OPT.Nodes; y: OPT.Nodes);
BEGIN
  IF x = NIL THEN x := y ELSE last.link := y;
  WHILE y.link <> NIL DO y := y.link;
  last := y
END;
	
FUNCTION BoolToInt(b: BOOLEAN): LONGINT;
BEGIN
  IF b THEN RESULT:= 1 ELSE RESULT:= 0
END;
	
FUNCTION IntToBool(i: LONGINT): BOOLEAN;
BEGIN
  IF i = 0 THEN RESULT:= FALSE ELSE RESULT:= TRUE
END;
	
FUNCTION NewBoolConst(boolval: BOOLEAN): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.typ := OPT.booltyp;
  x.conval := OPT.NewConst();
  x.conval^.intval := BoolToInt(boolval);
  RESULT:= x;
END;

PROCEDURE OptIf(VAR x: OPT.Nodes);	(* x.link = NIL *)
VAR
  Aif, pred: OPT.Nodes;
BEGIN
  Aif := x.left;
  WHILE Aif.left.clas = Nconst DO BEGIN
    IF IntToBool(Aif.left.conval^.intval) THEN BEGIN
      x := Aif.right;
      EXIT;
    END ELSE IF Aif.link = NIL THEN BEGIN
      x := x.right;
      EXIT;
    END ELSE BEGIN
      Aif := Aif.link;
      x.left := Aif;
    END;
  END ;
  pred := Aif;
  Aif := Aif.link;
  WHILE Aif <> NIL DO BEGIN
    IF Aif.left.clas = Nconst THEN BEGIN
      IF IntToBool(Aif.left.conval^.intval) THEN BEGIN
        pred.link := NIL;
        x.right := Aif.right;
        EXIT;
      END ELSE BEGIN
        Aif := Aif.link;
        pred.link := Aif;
      END
    END ELSE BEGIN
      pred := Aif;
      Aif := Aif.link;
    END;
  END;
END;

FUNCTION FNNil(): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.typ := OPT.niltyp;
  x.conval := OPT.NewConst();
  x.conval^.intval := OPM.nilval;
  RESULT:= x
END;

FUNCTION BoolConst(value: INTEGER): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.typ := OPT.booltyp;
  x.conval := OPT.NewConst();
  x.conval^.intval := value;
  RESULT:= x
END;

FUNCTION EmptySet(): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.typ := OPT.settyp;
  x.conval := OPT.NewConst();
  x.conval^.setval := [];
  RESULT:= x
END;

PROCEDURE SetIntType(node: OPT.Nodes);
VAR
  v: LONGINT;
BEGIN
  v := node.conval^.intval;
  IF (MinSInt <= v) AND (v <= MaxSInt) THEN
    node.typ := OPT.sinttyp
  ELSE IF (MinInt <= v) AND (v <= MaxInt) THEN
    node.typ := OPT.inttyp
  ELSE IF (MinLInt <= v) AND (v <= MaxLInt) (*bootstrap or cross*) THEN
    node.typ := OPT.linttyp
  ELSE BEGIN
    err(203);
    node.typ := OPT.sinttyp;
    node.conval^.intval := 1
  END;
END;

FUNCTION NewIntConst(intval: LONGINT): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.conval := OPT.NewConst();
  x.conval^.intval := intval;
  SetIntType(x);
  RESULT:= x
END;
	
FUNCTION NewRealConst(realval: DOUBLE; typ: OPT.Structs): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.conval := OPT.NewConst();
  x.conval^.realval:= realval;
  x.typ := typ;
  x.conval^.intval := OPM.ConstNotAlloc;
  RESULT:= x
END;

FUNCTION NewString(VAR str: STRING; len: LONGINT): OPT.Nodes;
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nconst);
  x.conval := OPT.NewConst();
  x.typ := OPT.stringtyp;
  x.conval^.intval := OPM.ConstNotAlloc;
  x.conval^.intval2 := len;
  x.conval^.ext := OPT.NewExt();
  x.conval^.ext := str;
  RESULT:= x
END;
	
PROCEDURE CharToString(n: OPT.Nodes);
VAR
  ch: CHAR;
BEGIN
  n.typ := OPT.stringtyp;
  ch := CHR(n.conval^.intval);
  n.conval^.ext := OPT.NewExt();
  IF ch = #0 THEN
    n.conval^.intval2 := 1
  ELSE
    n.conval^.intval2 := 2;
  n.conval^.ext[1] := ch;
  n.conval^.ext[2] := #0;
  n.conval^.intval := OPM.ConstNotAlloc;
  n.obj := NIL
END;

PROCEDURE BindNodes(Aclass: SHORTINT; typ: OPT.Structs; VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  node: OPT.Nodes;
BEGIN
  node := OPT.NewNode(Aclass);
  node.typ := typ;
  node.left := x;
  node.right := y;
  x := node
END;

FUNCTION NotVar(x: OPT.Nodes): BOOLEAN;
BEGIN 
  IF x.obj<>NIL THEN x.obj.used:=TRUE;
  RESULT:= (x.clas >= Nconst) AND ((x.clas <> Nmop) OR (x.subcl <> yval) OR (x.left.clas >= Nconst))
END;

PROCEDURE DeRef(VAR x: OPT.Nodes);
BEGIN
  IF (x.clas >= Nconst) AND (x.clas<>Ncall) THEN
    err(78)
  ELSe IF x.typ.form = sfPointer THEN
    BindNodes(Nderef, x.typ.BaseTyp, x, NIL)
  ELSE
    err(84);
END;

PROCEDURE Index(VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  f: INTEGER;
  typ: OPT.Structs;
BEGIN
  f := y.typ.form;
  IF x.clas >= Nconst THEN
    err(79)
  ELSe IF  NOT (f IN intSet) OR (y.clas IN [Nproc, Ntype]) THEN BEGIN
    err(80);
    y.typ := OPT.inttyp
  END;	(* JT, 25.08.96 *)
  IF x.typ.comp = csStaticArr THEN BEGIN
    typ := x.typ.BaseTyp;
    IF (y.clas = Nconst) AND ((y.conval^.intval < 0)
    OR ((y.conval^.intval >= x.typ.n))) THEN err(81);
  END ELSE IF x.typ.comp IN [csSDynArr, csDynArr, csOpenArr] THEN BEGIN
    typ := x.typ.BaseTyp;
    IF (y.clas = Nconst) AND (y.conval^.intval < 0) THEN err(81);
  END ELSE BEGIN
    err(82);
    typ := OPT.undftyp
  END ;
  BindNodes(Nindex, typ, x, y);
  x.readonly := x.left.readonly
END;

PROCEDURE Field(VAR x: OPT.Nodes; y: OPT.Objects);
BEGIN (*x.typ.comp = Record*)
  IF x.clas >= Nconst THEN
    err(77)
  ELSE IF (y <> NIL) AND (y.mode IN [omFld, omTProc]) THEN BEGIN
    BindNodes(Nfield, y.typ, x, NIL);
    x.obj := y;
    x.readonly := x.left.readonly OR ((y.vis = externalR) AND (y.mnolev < 0))
  END ELSE IF (y <> NIL) AND (y.mode IN [omCon]) THEN
    x := NewLeaf (y)
  ELSE BEGIN
    err(83);
    x.typ := OPT.undftyp
  END;
END;
	
PROCEDURE TypTest(VAR x: OPT.Nodes; obj: OPT.Objects; guard: BOOLEAN);

  PROCEDURE GTT(t0, t1: OPT.Structs);
  VAR
    node: OPT.Nodes;
    t: OPT.Structs;
  BEGIN
    OPT.MarkType(t1);
    t := t0;
    IF (t0.sysflag = notag) OR (t1.sysflag = notag) THEN err(200);
    WHILE (t <> NIL) AND (t <> t1) AND (t <> OPT.undftyp) DO t := t.BaseTyp;
    IF t <> t1 THEN BEGIN
      WHILE (t1 <> NIL) AND (t1 <> t0) AND (t1 <> OPT.undftyp) DO t1 := t1.BaseTyp;
      IF (t1 = t0) OR (x.typ = OPT.ptrtyp) THEN BEGIN
        IF guard THEN BEGIN
          BindNodes(Nguard, NIL, x, NIL);
          x.readonly := x.left.readonly;
        END ELSE BEGIN
          node := OPT.NewNode(Nmop);
          node.subcl := vis;
          node.left := x;
          node.obj := obj;
          x := node
        END
      END ELSE
        err(85)
    END ELSE IF t0 <> t1 THEN
      err(85)
    ELSE IF  NOT guard THEN BEGIN
      IF x.clas = Nguard THEN BEGIN	(* cannot skip guard *)
        node := OPT.NewNode(Nmop);
        node.subcl := vis;
        node.left := x;
        node.obj := obj;
        x := node
      END ELSE
        x := NewBoolConst(TRUE)
    END
  END;

BEGIN
  OPT.MarkObj(obj);
  IF NotVar(x) THEN
    err(112)
  ELSE IF x.typ.form = sfPointer THEN BEGIN
    IF obj.typ.form <> sfPointer THEN
      err(86)
    ELSE IF obj.typ.BaseTyp.comp <> csRecord THEN
      err(85)
    ELSE IF x.typ = OPT.ptrtyp THEN
      GTT(x.typ, obj.typ.BaseTyp)
    ELSE IF x.typ.BaseTyp.comp <> csRecord THEN
      err(85)
    ELSE
      GTT(x.typ.BaseTyp, obj.typ.BaseTyp);
  END ELSE IF (x.typ.comp = csRecord) AND ((x.clas = Nvarpar)
  OR(x.clas = Nderef)) AND (obj.typ.comp = csRecord) THEN
    GTT(x.typ, obj.typ)
  ELSE
    err(87);
  IF guard THEN x.typ := obj.typ ELSE x.typ := OPT.booltyp;
END;

PROCEDURE FNIn(VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  f: INTEGER;
  k: LONGINT;
BEGIN
  f := x.typ.form;
  IF (x.clas = Ntype) OR (x.clas = Nproc) OR (y.clas = Ntype)
  OR (y.clas = Nproc) THEN
    err(126)
  ELSE IF (f IN intSet) AND (y.typ.form = sfSet) THEN BEGIN
    IF x.clas = Nconst THEN BEGIN
      k := x.conval^.intval;
      IF (k < 0) OR (k > MaxSet) THEN
        err(202)
      ELSE IF y.clas = Nconst THEN BEGIN
        x.conval^.intval := BoolToInt(k IN y.conval^.setval);
        x.obj := NIL
      END ELSE BEGIN
        BindNodes(Ndop, OPT.booltyp, x, y);
        x.subcl := vin;
      END;
    END ELSE BEGIN
      BindNodes(Ndop, OPT.booltyp, x, y);
      x.subcl := vin;
    END
  END ELSE
    err(92);
  x.typ := OPT.booltyp
END;

FUNCTION log(x: LONGINT): LONGINT;
BEGIN exp := 0;
  IF x > 0 THEN
    WHILE  NOT ODD(x) DO BEGIN
      x := x DIV 2;
      INC(exp)
    END;
  RESULT:= x
END;

PROCEDURE CheckRealType(f, nr: INTEGER; x: OPT.Consts);
VAR
  min, max, r: DOUBLE;
BEGIN
  IF f = sfReal THEN BEGIN
    min := MinReal;
    max := MaxReal;
  END ELSE BEGIN
    min := MinLReal;
    max := MaxLReal;
  END ;
  r := SYSTEM.ABS(x.realval);
  IF (r > max) OR (r < min) THEN BEGIN
      err(nr);
      x.realval := 1.0
  END ELSE IF f = sfReal THEN
    x.realval := REAL(x.realval);	(* single precision only *)
  x.intval := OPM.ConstNotAlloc
END;
	
PROCEDURE MOp(op: SHORTINT; VAR x: OPT.Nodes);
VAR
  f: INTEGER;
  typ: OPT.Structs;
  z: OPT.Nodes;
		
  FUNCTION NewOp(op: SHORTINT; typ: OPT.Structs; z: OPT.Nodes): OPT.Nodes;
  VAR
    node: OPT.Nodes;
  BEGIN
    node := OPT.NewNode(Nmop);
    node.subcl := op;
    node.typ := typ;
    node.left := z;
    RESULT:= node
  END;

BEGIN
  z := x;
  IF ((z.clas = Ntype) OR (z.clas = Nproc))  AND (op <> ytype) THEN
    err(126)
  ELSE BEGIN
    typ := z.typ;
    f := typ.form;
    CASE op OF
      vnot:
                  IF f = sfBool THEN BEGIN
                    IF z.clas = Nconst THEN BEGIN
                      z.conval^.intval := BoolToInt( NOT IntToBool(z.conval^.intval));
                      z.obj := NIL;
                    END ELSE
                      z := NewOp(op, typ, z);
                  END ELSE
                    err(98);
      vplus:      IF  NOT (f IN intSet + realSet) THEN err(96);
      vminus:
                  IF f IN intSet + realSet +[sfSet]THEN BEGIN
                    IF z.clas = Nconst THEN BEGIN
                      IF f IN intSet THEN BEGIN
                        IF z.conval^.intval = MIN(_LONGINTS) THEN
                          err(203)
                        ELSE BEGIN
                          z.conval^.intval := -z.conval^.intval;
                          SetIntType(z)
                        END;
                      END ELSE IF f IN realSet THEN
                        z.conval^.realval := -z.conval^.realval
                      ELSE
                        INTEGER(z.conval^.setval) := -INTEGER(z.conval^.setval); //!!!
                      z.obj := NIL
                    END ELSE
                      z := NewOp(op, typ, z);
                  END ELSE
                    err(97);
      vabs:
                  IF f IN intSet + realSet THEN BEGIN
                    IF z.clas = Nconst THEN BEGIN
                      IF f IN intSet THEN BEGIN
                        IF z.conval^.intval = MIN(_LONGINTS) THEN
                          err(203)
                        ELSE BEGIN
                          z.conval^.intval := ABS(z.conval^.intval);
                          SetIntType(z);
                        END;
                      END ELSE
                        z.conval^.realval := SYSTEM.ABS(z.conval^.realval);
                      z.obj := NIL
                    END ELSE
                      z := NewOp(op, typ, z);
                  END ELSE
                    err(111);
      vcap:
                  IF f = sfChar THEN BEGIN
                    IF z.clas = Nconst THEN BEGIN
                      z.conval^.intval := ORD(CAP(CHR(z.conval^.intval)));
                      z.obj := NIL
                    END ELSE
                      z := NewOp(op, typ, z);
                  END ELSE BEGIN
                    err(111);
                    z.typ := OPT.chartyp
                  END;
      vodd:
                  BEGIN
                    IF f IN intSet THEN BEGIN
                      IF z.clas = Nconst THEN BEGIN
                        z.conval^.intval := BoolToInt(ODD(z.conval^.intval));
                        z.obj := NIL
                      END ELSE
                        z := NewOp(op, typ, z);
                    END ELSE
                      err(111);
                    z.typ := OPT.booltyp
                  END;
      yadr: (*SYSTEM.ADR*)
                  BEGIN
                    IF (z.clas < Nconst) OR (f = sfString) THEN
                      z := NewOp(op, typ, z)
                    ELSE
                      err(127);
                    z.typ := OPT.linttyp;
                  END;
      ycc: (*SYSTEM.CC*)
                  BEGIN
                    IF (f IN intSet) AND (z.clas = Nconst) THEN BEGIN
                      IF (0 <= z.conval^.intval) AND (z.conval^.intval <= OPM.MaxCC) THEN
                        z := NewOp(op, typ, z)
                      ELSE
                        err(219);
                    END ELSE
                      err(69);
                    z.typ := OPT.booltyp;
                  END;
      yget8:      z := NewOp(op, OPT.sinttyp, z);
      yget16:     z := NewOp(op, OPT.inttyp, z);
      yget32:     z := NewOp(op, OPT.linttyp, z);
      ytype:
                  BEGIN
                    OPT.MarkType(z.typ);
                    z := NewOp(op, OPT.linttyp, z);
                  END;
    END;
  END;
  x := z;
END;

PROCEDURE CheckPtr(VAR x, y: OPT.Nodes);
VAR
  g: INTEGER;
  p, q, t: OPT.Structs;
BEGIN
  g := y.typ.form;	(* x.typ # y.typ , x is pointer, otherwise it wouldn't enter here! *)
  IF g = sfPointer THEN BEGIN
    p := x.typ.BaseTyp;
    q := y.typ.BaseTyp;
    IF (x.typ = OPT.ptrtyp) OR (y.typ = OPT.ptrtyp) THEN (* allowed *)
    ELSE IF (p.comp = csRecord) AND (q.comp = csRecord) THEN BEGIN
      IF p.extlev < q.extlev THEN BEGIN
        t := p;
        p := q;
        q := t
      END ;
      WHILE (p <> q) AND (p <> NIL) AND (p <> OPT.undftyp) DO p := p.BaseTyp;
      IF p = NIL THEN err(100);
    END ELSE
      err(100);
  END ELSE IF x.typ.BaseTyp.comp IN ArraySet THEN BEGIN
    IF y.typ.comp IN ArraySet THEN
      DeRef(x)
    ELSE IF y.typ.form = sfString THEN
      DeRef(x)
    ELSE IF g = sfNilTyp THEN (* allow nil test *)
    ELSE
      err(100);
  END ELSE IF (y.typ.comp = csRecord) AND (y.obj <> NIL) AND (y.obj.name = '@SELF') THEN
    err(170)
  ELSE IF g <> sfNilTyp THEN
    err(100);
END;
	
PROCEDURE CheckParameters(fp, ap: OPT.Objects; checkNames: BOOLEAN);
VAR
  ft, at: OPT.Structs;
BEGIN
  WHILE fp <> NIL DO BEGIN
    IF ap <> NIL THEN BEGIN
      ft := fp.typ;
      at := ap.typ;
      IF ft.sysflag <> at.sysflag THEN err(115);
      WHILE (ft.comp = csOpenArr) AND (at.comp = csOpenArr) DO BEGIN
        ft := ft.BaseTyp;
        at := at.BaseTyp
      END ;
      IF ft <> at THEN BEGIN
        IF (ft.form = sfProcTyp) AND (at.form = sfProcTyp) THEN BEGIN
          IF ft.BaseTyp = at.BaseTyp THEN
            CheckParameters(ft.link, at.link, FALSE)
          ELSE
            err(117);
        END ELSE
          err(115);
      END;
      IF (fp.mode <> ap.mode) OR checkNames AND (fp.name <> ap.name) THEN err(115);
      ap := ap.link
    END ELSE
      err(116);
    fp := fp.link
  END;
  IF ap <> NIL THEN err(116);
END;

PROCEDURE CheckProc(x: OPT.Structs; y: OPT.Objects);	(* proc var x := proc y, check compatibility *)
BEGIN
  IF y.mode IN [omXProc, omIProc, omLProc] THEN BEGIN
    IF y.mode = omLProc THEN BEGIN
      IF y.mnolev = 0 THEN
        y.mode := omXProc
      ELSE
        err(73);
    END;
    IF x.BaseTyp = y.typ THEN
      CheckParameters(x.link, y.link, FALSE)
    ELSE
      err(117);
    IF x.sysflag <> y.sysflag THEN BEGIN
      IF x.sysflag <> 0 THEN
        err(113)
      ELSE IF y.sysflag = cdecl THEN
        err(113);
    END
  END ELSE
    err(113);
END;

PROCEDURE ConstOp(op: INTEGER; x, y: OPT.Nodes);
VAR
  f, g: INTEGER;
  xval, yval: OPT.Consts;
  xv, yv: LONGINT;
  temp: BOOLEAN; (* temp avoids err 215 *)

  FUNCTION ConstCmp(): INTEGER;
  VAR
    res: INTEGER;
  BEGIN
    res:=0;
    CASE f OF
      sfUndef:        res := veql;
      sfByte,
      sfChar..sfLInt:
                      IF xval.intval < yval.intval THEN
                        res := vlss
                      ELSE IF xval.intval > yval.intval THEN
                        res := vgtr
                      ELSE
                        res := veql;
      sfReal, sfLReal:
                      IF xval.realval < yval.realval THEN
                        res := vlss
                      ELSE IF xval.realval > yval.realval THEN
                        res := vgtr
                      ELSE
                        res := veql;
      sfBool:
                      IF xval.intval <> yval.intval THEN
                        res := vneq
                      ELSE
                        res := veql;
      sfSet:
                      IF xval.setval <> yval.setval THEN
                        res := vneq
                      ELSE
                        res := veql;
      sfString:
                      IF xval.ext < yval.ext THEN
                        res := vlss
                      ELSE IF xval.ext > yval.ext THEN
                        res := vgtr
                      ELSE
                        res := veql;
      sfNilTyp,
      sfPointer, sfProcTyp:
                      IF xval.intval <> yval.intval THEN
                        res := vneq
                      ELSE
                        res := veql;
    END ;
    x.typ := OPT.booltyp;
    RESULT:= res
  END;

BEGIN
  f := x.typ.form;
  g := y.typ.form;
  xval := x.conval;
  yval := y.conval;
  IF f <> g THEN BEGIN
    CASE f OF
      sfChar:
                  IF g = sfString THEN
                    CharToString(x)
                  ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval;
                  END ;
      sfSInt:
                  IF g IN intSet THEN
                    x.typ := y.typ
                  ELSE IF g = sfReal THEN BEGIN
                    x.typ := OPT.realtyp;
                    xval.realval := xval.intval;
                  END ELSE IF g = sfLReal THEN BEGIN
                    x.typ := OPT.lrltyp;
                    xval.realval := xval.intval;
                  END ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval;
                  END;
      sfInt:
                  IF g = sfSInt THEN
                    y.typ := OPT.inttyp
                  ELSE IF g IN intSet THEN
                    x.typ := y.typ
                  ELSE IF g = sfReal THEN BEGIN
                    x.typ := OPT.realtyp;
                    xval.realval := xval.intval;
                  END ELSE IF g = sfLReal THEN BEGIN
                    x.typ := OPT.lrltyp;
                    xval.realval := xval.intval;
                  END ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval
                  END;
      sfLInt:
                  IF g IN intSet THEN
                    y.typ := OPT.linttyp
                  ELSE IF g = sfReal THEN BEGIN
                    x.typ := OPT.realtyp;
                    xval.realval := xval.intval
                  END ELSE IF g = sfLReal THEN BEGIN
                    x.typ := OPT.lrltyp;
                    xval.realval := xval.intval
                  END ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval
                  END;
      sfReal:
                  IF g IN intSet THEN BEGIN
                    y.typ := x.typ;
                    yval.realval := yval.intval;
                  END ELSE IF g = sfLReal THEN
                    x.typ := OPT.lrltyp
                  ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval;
                  END;
      sfLReal:
                  IF g IN intSet THEN BEGIN
                    y.typ := x.typ;
                    yval.realval := yval.intval
                  END ELSE IF g = sfReal THEN
                    y.typ := OPT.lrltyp
                  ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval
                  END;
      sfString:
                  IF g = sfChar THEN BEGIN
                    CharToString(y);
                    //g := sfString;
                  END ELSE BEGIN
                    err(100);
                    y.typ := x.typ;
                    yval := xval;
                  END ;
      sfNilTyp:   IF  NOT (g IN [sfPointer, sfProcTyp]) THEN err(100);
      sfPointer:  CheckPtr(x, y);
      sfProcTyp:  IF g <> sfNilTyp THEN err(100);
    ELSE
      err(100);
      y.typ := x.typ;
      yval := xval
    END ;
    f := x.typ.form
  END;	(* [x.typ = y.typ] *)

  CASE op OF
    vtimes:
                  IF f IN intSet THEN BEGIN
                    xv := xval.intval;
                    yv := yval.intval;
                    IF (xv = 0) OR (yv = 0) OR	(* division with negative numbers is not defined *)
                      (xv > 0) AND (yv > 0) AND (yv <= MAX(_LONGINTS) DIV xv) OR
                      (xv > 0) AND (yv < 0) AND (yv >= MIN(_LONGINTS) DIV xv) OR
                      (xv < 0) AND (yv > 0) AND (xv >= MIN(_LONGINTS) DIV yv) OR
                      (xv < 0) AND (yv < 0) AND (xv <> MIN(_LONGINTS))
                      AND (yv <> MIN(_LONGINTS)) AND (-xv <= MAX(_LONGINTS) DIV (-yv)) THEN BEGIN
                      xval.intval := xv * yv;
                      SetIntType(x)
                    END ELSE
                      err(204);
                  END ELSE IF f IN realSet THEN BEGIN
                    temp := SYSTEM.ABS(yval.realval) <= 1.0;
                    IF temp OR (SYSTEM.ABS(xval.realval) <= MAX(_LONGREALS) / SYSTEM.ABS(yval.realval)) THEN BEGIN
                      xval.realval := xval.realval * yval.realval;
                      CheckRealType(f, 204, xval);
                    END ELSE
                      err(204);
                  END ELSE IF f = sfSet THEN
                    xval.setval := xval.setval * yval.setval
                  ELSE IF f <> sfUndef THEN
                    err(101);
    vslash:
                  IF f IN intSet THEN BEGIN
                    IF yval.intval <> 0 THEN BEGIN
                      xval.realval := xval.intval / yval.intval;
                      CheckRealType(sfReal, 205, xval);
                    END ELSE BEGIN
                      err(205);
                      xval.realval := 1.0
                    END;
                    x.typ := OPT.realtyp
                  END ELSE IF f IN realSet THEN BEGIN
                    temp := SYSTEM.ABS(yval.realval) >= 1.0;
                    IF temp OR (SYSTEM.ABS(xval.realval) <= MAX(_LONGREALS) * SYSTEM.ABS(yval.realval)) THEN BEGIN
                      xval.realval := xval.realval / yval.realval;
                      CheckRealType(f, 205, xval)
                    END ELSE
                      err(205);
                  END ELSE IF f = sfSet THEN
                    INTEGER(xval.setval) := INTEGER(xval.setval) XOR INTEGER(yval.setval) //!!!
                  ELSE IF f <> sfUndef THEN
                    err(102);
    vdiv:
                  IF f IN intSet THEN BEGIN
                    IF yval.intval <> 0 THEN BEGIN
                      xval.intval := xval.intval DIV yval.intval;
                      SetIntType(x);
                    END ELSE
                      err(205);
                  END ELSE IF f <> sfUndef THEN
                    err(103);
    vmod:
                  IF f IN intSet THEN BEGIN
                    IF yval.intval <> 0 THEN BEGIN
                      xval.intval := xval.intval MOD yval.intval;
                      SetIntType(x)
                    END ELSE
                      err(205);
                  END ELSE IF f <> sfUndef THEN
                    err(104);
    vand:
                  IF f = sfBool THEN BEGIN
                    xval.intval := BoolToInt(IntToBool(xval.intval) AND IntToBool(yval.intval))
                  END ELSE
                    err(94);
    vplus:
                  IF f IN intSet THEN BEGIN
                    temp := (yval.intval >= 0) AND (xval.intval <= MAX(_LONGINTS) - yval.intval);
                    IF temp OR (yval.intval < 0) AND (xval.intval >= MIN(_LONGINTS) - yval.intval) THEN BEGIN
                      INC(xval.intval, yval.intval);
                      SetIntType(x);
                    END ELSE
                      err(206);
                  END ELSE IF f IN realSet THEN BEGIN
                    temp := (yval.realval >= 0.0) AND (xval.realval <= MAX(_LONGREALS) - yval.realval);
                    IF temp OR (yval.realval < 0.0) AND (xval.realval >= -MAX(_LONGREALS) - yval.realval) THEN BEGIN
                      xval.realval := xval.realval + yval.realval;
                      CheckRealType(f, 206, xval)
                    END ELSE
                      err(206);
                  END ELSE IF f = sfSet THEN
                    xval.setval := xval.setval + yval.setval
                  ELSE IF f <> sfUndef THEN
                    err(105);
    vminus:
                  IF f IN intSet THEN BEGIN
                    IF (yval.intval >= 0) AND (xval.intval >= MIN(_LONGINTS) + yval.intval) OR
                      (yval.intval < 0) AND (xval.intval <= MAX(_LONGINTS) + yval.intval) THEN BEGIN
                        DEC(xval.intval, yval.intval);
                        SetIntType(x)
                    END ELSE
                      err(207);
                  END ELSE IF f IN realSet THEN BEGIN
                    temp := (yval.realval >= 0.0) AND (xval.realval >= -MAX(_LONGREALS) + yval.realval);
                    IF temp OR (yval.realval < 0.0) AND (xval.realval <= MAX(_LONGREALS) + yval.realval) THEN BEGIN
                      xval.realval := xval.realval - yval.realval;
                      CheckRealType(f, 207, xval)
                    END ELSE
                      err(207);
                  END ELSE IF f = sfSet THEN
                    xval.setval := xval.setval - yval.setval
                  ELSE IF f <> sfUndef THEN
                    err(106);
    vor:
                  IF f = sfBool THEN
                    xval.intval := BoolToInt(IntToBool(xval.intval) OR IntToBool(yval.intval))
                  ELSE
                    err(95);
    veql:         xval.intval := BoolToInt(ConstCmp() = veql);
    vneq:         xval.intval := BoolToInt(ConstCmp() <> veql);
    vlss:
                  IF f IN [sfBool, sfSet, sfNilTyp, sfPointer] THEN
                    err(108)
                  ELSE
                    xval.intval := BoolToInt(ConstCmp() = vlss);
    vleq:
                  IF f IN [sfBool, sfSet, sfNilTyp, sfPointer] THEN
                    err(108)
                  ELSE
                    xval.intval := BoolToInt(ConstCmp() <> vgtr);
    vgtr:
                  IF f IN [sfBool, sfSet, sfNilTyp, sfPointer] THEN
                    err(108)
                  ELSE
                    xval.intval := BoolToInt(ConstCmp() = vgtr);
    vgeq:
                  IF f IN [sfBool, sfSet, sfNilTyp, sfPointer] THEN
                    err(108)
                  ELSE
                    xval.intval := BoolToInt(ConstCmp() <> vlss);
  END
END;

PROCEDURE Convert(VAR x: OPT.Nodes; typ: OPT.Structs);
VAR
  node: OPT.Nodes;
  f, g: INTEGER;
  k: LONGINT;
  r: DOUBLE;
BEGIN
  f := x.typ.form;
  g := typ.form;
  IF x.clas = Nconst THEN BEGIN
    IF f IN intSet THEN BEGIN
      IF g IN intSet THEN BEGIN
        IF f > g THEN BEGIN
          SetIntType(x);
          IF x.typ.form > g THEN BEGIN
            err(203);
            x.conval^.intval := 1
          END;
        END;
      END ELSE IF g IN realSet THEN BEGIN
        x.conval^.realval := x.conval^.intval;
        x.conval^.intval := OPM.ConstNotAlloc
      END ELSE BEGIN(*g = Char*)
        k := x.conval^.intval;
        IF (0 > k) OR (k > $0FF) THEN err(220);
      END;
    END ELSE IF f IN realSet THEN BEGIN
      IF g IN realSet THEN
        CheckRealType(g, 203, x.conval)
      ELSE BEGIN(*g = LInt*)
        r := x.conval^.realval;
        IF (r < MIN(_LONGINTS)) OR (r > MAX(_LONGINTS)) THEN BEGIN
          err(203);
          r := 1
        END ;
        x.conval^.intval := TRUNC(r);
        SetIntType(x);
      END
    END ELSE ; (* (f IN [Char, Byte]) AND (g IN [Byte] + intSet) OR (f = Undef) *)
    x.obj := NIL
  END ELSE IF (x.clas = Nmop) AND (x.subcl = vconv)
  AND ((x.left.typ.form < f) OR (f > g)) THEN BEGIN
    (* don't create new node *)
    IF x.left.typ = typ THEN (* and suppress existing node *) x := x.left;
  END ELSE BEGIN
    node := OPT.NewNode(Nmop);
    node.subcl := vconv;
    node.left := x;
    x := node;
  END ;
  x.typ := typ
END;

PROCEDURE FNVal(VAR x: OPT.Nodes;  typ: OPT.Structs);	(*SYSTEM.VAL, change type, no convertion only projection*)
VAR
  t: OPT.Nodes;
  f: INTEGER;
  r: REAL;
BEGIN
  f := x.typ.form;
  IF (x.clas = Ntype) OR (x.clas = Nproc) OR
    (f IN [sfUndef, sfString, sfNoTyp]) THEN err(126);
  IF (x.clas = Nconst) AND (typ.comp = csBasic) THEN BEGIN
    IF (typ.form = sfReal) AND (f IN intSet) THEN
      x := NewRealConst(x.conval^.intval, typ)
    ELSE IF (typ.form IN intSet) AND (f = sfReal) THEN BEGIN
      r := x.conval^.realval;
      x := NewIntConst(TRUNC(r));
    END ELSE IF (typ.form IN [sfSInt, sfInt]) AND (f IN intSet) THEN BEGIN	(*force sign extension*)
      IF typ.form = sfSInt THEN
        x := NewIntConst (x.conval^.intval)
      ELSE IF typ.form = sfInt THEN
        x := NewIntConst (x.conval^.intval);
    END ELSE IF (typ.form IN intSet) AND (f = sfSet) THEN
      x.conval^.intval := LONGINT(x.conval^.setval)
    ELSE IF (typ.form = sfSet) AND (f IN intSet) THEN
      INTEGER(x.conval^.setval) := x.conval^.intval
    ELSE BEGIN
      t := OPT.NewNode(Nmop);
      t.subcl := yval;
      t.left := x;
      x := t;
    END
  END ELSE IF (x.clas >= Nconst) THEN BEGIN
    t := OPT.NewNode(Nmop);
    t.subcl := yval;
    t.left := x;
    x := t;
  END ELSE BEGIN
    IF (f IN realSet) THEN BEGIN
      IF (typ.form IN realSet) THEN
        x.readonly := FALSE
      ELSE BEGIN
        t := OPT.NewNode(Nmop);
        t.subcl := yval;
        t.left := x;
        x := t
      END
    END ELSE IF (typ.form IN realSet) THEN BEGIN
      t := OPT.NewNode(Nmop);
      t.subcl := yval;
      t.left := x;
      x := t;
    END ELSE
      x.readonly := FALSE;
  END;
  x.typ := typ;
END;

PROCEDURE Op(op: SHORTINT; VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  f, g: INTEGER;
  t, z: OPT.Nodes;
  typ: OPT.Structs;
  Ado: BOOLEAN;
  val: LONGINT;

  PROCEDURE NewOp(op: SHORTINT; typ: OPT.Structs; VAR x: OPT.Nodes; y: OPT.Nodes);
  VAR
    node: OPT.Nodes;
  BEGIN
    node := OPT.NewNode(Ndop);
    node.subcl := op;
    node.typ := typ;
    node.left := x;
    node.right := y;
    x := node
  END;

  FUNCTION Strings(VAR x, y: OPT.Nodes): BOOLEAN;
  VAR
    ok, xCharArr, yCharArr: BOOLEAN;
  BEGIN
    xCharArr := ((x.typ.comp IN ArraySet) AND (x.typ.BaseTyp.form=sfChar)) OR (f=sfString);
    yCharArr := (((y.typ.comp IN ArraySet) AND (y.typ.BaseTyp.form=sfChar)) OR (g=sfString));
    IF xCharArr AND (g = sfChar) AND (y.clas = Nconst) THEN BEGIN
      CharToString(y);
      g := sfString;
      yCharArr := TRUE
    END;
    IF yCharArr AND (f = sfChar) AND (x.clas = Nconst) THEN BEGIN
      CharToString(x);
      f := sfString;
      xCharArr := TRUE
    END;
    ok := xCharArr AND yCharArr;
    IF ok THEN BEGIN(* replace ""-string compare with 0X-char compare, if possible *)
      IF (f=sfString) AND (x.conval^.intval2 = 1) THEN	BEGIN(* y is array of char *)
        x.typ := OPT.chartyp;
        x.conval^.intval := 0;
        Index(y, NewIntConst(0))
      END ELSE IF (g=sfString) AND (y.conval^.intval2 = 1) THEN BEGIN	(* x is array of char *)
        y.typ := OPT.chartyp;
        y.conval^.intval := 0;
        Index(x, NewIntConst(0))
      END;
    END;
    RESULT:= ok
  END;

BEGIN
  z := x;
  IF (z.clas = Ntype) OR (z.clas = Nproc) OR (y.clas = Ntype) OR (y.clas = Nproc) THEN
    err(126)
  ELSE IF (z.clas = Nconst) AND (y.clas = Nconst) THEN BEGIN
    ConstOp(op, z, y);
    z.obj := NIL;
  END ELSE BEGIN
    IF z.typ <> y.typ THEN BEGIN
      g := y.typ.form;
      CASE z.typ.form OF
        sfChar:
                  IF z.clas = Nconst THEN
                    CharToString(z)
                  ELSE
                    err(100);
        sfSInt:
                  IF g IN intSet + realSet THEN
                    Convert(z, y.typ)
                  ELSE
                    err(100);
        sfInt:
                  IF g = sfSInt THEN
                    Convert(y, z.typ)
                  ELSE IF g IN intSet + realSet THEN
                    Convert(z, y.typ)
                  ELSE
                    err(100);
        sfLInt:
                  IF g IN intSet THEN
                    Convert(y, z.typ)
                  ELSE IF g IN realSet THEN
                    Convert(z, y.typ)
                  ELSE
                    err(100);
        sfReal:
                  IF g IN intSet THEN
                    Convert(y, z.typ)
                  ELSE IF g IN realSet THEN
                    Convert(z, y.typ)
                  ELSE
                    err(100);
        sfLReal:
                  IF g IN intSet + realSet THEN
                    Convert(y, z.typ)
                  ELSE IF g IN realSet THEN
                    Convert(y, z.typ)
                  ELSE
                    err(100);
        sfNilTyp: IF  NOT (g IN [sfPointer, sfProcTyp]) THEN err(100);
        sfPointer:CheckPtr(z, y);
        sfProcTyp:IF g <> sfNilTyp THEN err(100);
        sfString: ;
        sfComp:
                  IF z.typ.comp = csRecord THEN BEGIN
                    IF (g = sfPointer) AND (z.obj <> NIL) AND (z.obj.name = '@SELF') THEN
                      err(170)
                    ELSE
                      err(100);
                  END;
      ELSE
        err(100)
      END;
    END;	(* [z.typ = y.typ] *)

    typ := z.typ;
    f := typ.form;
    g := y.typ.form;

    CASE op OF
      vtimes:
                  BEGIN
                    Ado := TRUE;
                    IF f IN intSet THEN BEGIN
                      IF z.clas = Nconst THEN BEGIN
                        val := z.conval^.intval;
                        IF val = 1 THEN BEGIN
                          Ado := FALSE;
                          z := y
                        END ELSE IF val = 0 THEN
                          Ado := FALSE
                        ELSE IF log(val) = 1 THEN BEGIN
                          t := y;
                          y := z;
                          z := t;
                          op := vash;
                          y.typ := OPT.sinttyp;
                          y.conval^.intval := exp;
                          y.obj := NIL
                        END;
                      END ELSE IF y.clas = Nconst THEN BEGIN
                        val := y.conval^.intval;
                        IF val = 1 THEN
                          Ado := FALSE
                        ELSE IF val = 0 THEN BEGIN
                          Ado := FALSE;
                          z := y
                        END ELSE IF (log(val) = 1) AND NOT (ovflchk IN OPM.options) THEN BEGIN
                          op := vash;
                          y.typ := OPT.sinttyp;
                          y.conval^.intval := exp;
                          y.obj := NIL
                        END
                      END
                    END ELSE IF NOT (f IN [sfUndef, sfReal..sfSet]) THEN BEGIN
                      err(105);
                      typ := OPT.undftyp
                    END ;
                    IF Ado THEN
                      NewOp(op, typ, z, y);
                  END;
      vslash:
                  BEGIN
                    IF f IN intSet THEN BEGIN
                      IF (y.clas = Nconst) AND (y.conval^.intval = 0) THEN err(205);
                      Convert(z, OPT.realtyp);
                      Convert(y, OPT.realtyp);
                      typ := OPT.realtyp
                    END ELSE IF f IN realSet THEN BEGIN
                      IF (y.clas = Nconst) AND (y.conval^.realval = 0.0) THEN err(205);
                    END ELSE IF (f <> sfSet) AND (f <> sfUndef) THEN BEGIN
                      err(102);
                      typ := OPT.undftyp
                    END ;
                    NewOp(op, typ, z, y);
                  END;
      vdiv:
                  BEGIN
                    Ado := TRUE;
                    IF f IN intSet THEN BEGIN
                      IF y.clas = Nconst THEN BEGIN
                        val := y.conval^.intval;
                        IF val = 0 THEN
                          err(205)
                        ELSE IF val = 1 THEN
                          Ado := FALSE
                        ELSE IF log(val) = 1 THEN BEGIN
                          op := vash;
                          y.typ := OPT.sinttyp;
                          y.conval^.intval := -exp;
                          y.obj := NIL
                        END;
                      END;
                    END ELSE IF f <> sfUndef THEN BEGIN
                      err(103);
                      typ := OPT.undftyp
                    END ;
                    IF Ado THEN
                      NewOp(op, typ, z, y);
                  END;
      vmod:
                  BEGIN
                    IF f IN intSet THEN BEGIN
                      IF y.clas = Nconst THEN BEGIN
                        IF y.conval^.intval = 0 THEN
                          err(205)
                        ELSE IF y.conval^.intval = 1 THEN BEGIN              (* <== optimize x MOD 1 = 0 *)
                          x := OPT.NewNode(Nconst);
                          x.typ := typ;
                          x.conval := OPT.NewConst();
                          x.conval^.intval := 0;
                          EXIT;
                        END ELSE IF log(y.conval^.intval) = 1 THEN BEGIN
                          op := vmsk;
                          y.conval^.intval := ASH(-1, exp);
                          y.obj := NIL
                        END
                      END
                    END ELSE IF f <> sfUndef THEN BEGIN
                      err(104);
                      typ := OPT.undftyp;
                    END ;
                    NewOp(op, typ, z, y);
                  END;
      vand:
                  BEGIN
                    IF f = sfBool THEN BEGIN
                      IF z.clas = Nconst THEN BEGIN
                        IF IntToBool(z.conval^.intval) THEN z := y;
                      END ELSE IF (y.clas = Nconst) AND IntToBool(y.conval^.intval) THEN
                      ELSE
                        NewOp(op, typ, z, y);
                    END ELSE IF f <> sfUndef THEN BEGIN
                      err(94);
                      z.typ := OPT.undftyp;
                    END;
                  END;
      vplus:
                  BEGIN
                    IF  NOT (f IN [sfUndef, sfSInt..sfSet]) THEN BEGIN
                      err(105);
                      typ := OPT.undftyp;
                    END ;
                    Ado := TRUE;
                    IF f IN intSet THEN BEGIN
                      IF (z.clas = Nconst) AND (z.conval^.intval = 0) THEN BEGIN
                        Ado := FALSE;
                        z := y
                      END;
                      IF (y.clas = Nconst) AND (y.conval^.intval = 0) THEN Ado := FALSE;
                    END ;
                    IF Ado THEN
                      NewOp(op, typ, z, y);
                  END;
      vminus:
                  BEGIN
                    IF  NOT (f IN [sfUndef, sfSInt..sfSet]) THEN BEGIN
                      err(106);
                      typ := OPT.undftyp
                    END;
                    IF  NOT (f IN intSet) OR (y.clas <> Nconst) OR (y.conval^.intval <> 0) THEN
                      NewOp(op, typ, z, y);
                  END;
      vor:
                  BEGIN
                    IF f = sfBool THEN BEGIN
                      IF z.clas = Nconst THEN BEGIN
                        IF NOT IntToBool(z.conval^.intval) THEN z := y;
                      END ELSE IF (y.clas = Nconst) AND NOT IntToBool(y.conval^.intval) THEN
                      ELSE
                        NewOp(op, typ, z, y);
                    END ELSE IF f <> sfUndef THEN BEGIN
                      err(95);
                      z.typ := OPT.undftyp;
                    END;
                  END;
      veql, vneq:
                  BEGIN
                    IF (f IN [sfUndef..sfSet, sfNilTyp, sfPointer, sfProcTyp]) OR Strings(z, y) THEN
                      typ := OPT.booltyp
                    ELSE BEGIN
                      err(107);
                      typ := OPT.undftyp;
                    END ;
                    NewOp(op, typ, z, y)
                  END;
      vlss, vleq,
      vgtr, vgeq:
                  BEGIN
                    IF (f IN [sfUndef, sfChar..sfLReal]) OR strings(z, y) THEN
                      typ := OPT.booltyp
                    ELSE BEGIN
                      err(108);
                      typ := OPT.undftyp;
                    END ;
                    NewOp(op, typ, z, y);
                  END;
    END;
  END ;
  x := z;
END;

PROCEDURE SetRange(VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  k, l: LONGINT;
BEGIN
  k:=0;
  l:=0;
  IF (x.clas = Ntype) OR (x.clas = Nproc) OR (y.clas = Ntype) OR (y.clas = Nproc) THEN
    err(126)
  ELSE IF (x.typ.form IN intSet) AND (y.typ.form IN intSet) THEN BEGIN
    IF x.clas = Nconst THEN BEGIN
      k := x.conval^.intval;
      IF (0 > k) OR (k > MaxSet) THEN err(202);
    END ;
    IF y.clas = Nconst THEN BEGIN
      l := y.conval^.intval;
      IF (0 > l) OR (l > MaxSet) THEN err(202);
    END ;
    IF (x.clas = Nconst) AND (y.clas = Nconst) THEN BEGIN
      IF k <= l THEN
        x.conval^.setval := [k..l]
      ELSE BEGIN
        err(201);
        x.conval^.setval := [l..k]
      END ;
      x.obj := NIL;
    END ELSE
      BindNodes(Nupto, OPT.settyp, x, y);
  END ELSE
    err(93);
  x.typ := OPT.settyp
END;

PROCEDURE SetElem(VAR x: OPT.Nodes);
VAR
  k: LONGINT;
BEGIN
  IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
    err(126)
  ELSE IF  NOT (x.typ.form IN intSet) THEN
    err(93)
  ELSE IF x.clas = Nconst THEN BEGIN
    k := x.conval^.intval;
    IF (0 <= k) AND (k <= MaxSet) THEN
      x.conval^.setval := [k]
    ELSE
      err(202);
    x.obj := NIL
  END ELSE
    Convert(x, OPT.settyp);
  x.typ := OPT.settyp
END;
	
PROCEDURE CheckAssign(x: OPT.Structs; ynode: OPT.Nodes);	(* x := y *)
VAR
  f, g: INTEGER;
  y, p, q: OPT.Structs;
BEGIN
  y := ynode.typ;
  f := x.form;
  g := y.form;
  IF (ynode.clas = Ntype) OR (ynode.clas = Nproc) AND (f <> sfProcTyp) THEN err(126);
  CASE f OF
    sfUndef, sfString: ;
    sfByte:     IF  NOT (g IN [sfByte, sfChar, sfSInt]) THEN err(113);
    sfBool, sfChar, sfSInt, sfSet, sfHInt: IF g <> f THEN err(113);
    sfInt:      IF  NOT (g IN [sfSInt, sfInt]) THEN err(113);
    sfLInt:     IF  NOT (g IN intSet) THEN err(113);
    sfReal:     IF  NOT (g IN [sfSInt..sfReal]) THEN err(113);
    sfLReal:    IF  NOT (g IN [sfSInt..sfLReal]) THEN err(113);
    sfPointer:
                BEGIN
                  IF (x = y) OR (g = sfNilTyp) OR (x = OPT.ptrtyp) AND (g = sfPointer) THEN (* ok *)
                  ELSE IF g = sfPointer THEN BEGIN
                    p := x.BaseTyp;
                    q := y.BaseTyp;
                    IF (p.comp = csRecord) AND (q.comp = csRecord) THEN BEGIN
                      WHILE (q <> p) AND (q <> NIL) AND (q <> OPT.undftyp) DO q := q.BaseTyp;
                      IF q = NIL THEN err(113);
                    END ELSE
                      err(113);
                  END ELSE IF (y.comp = csRecord) AND (ynode.obj <> NIL)
                  AND (ynode.obj.name = '@SELF') THEN
                    err(170)
                  ELSE
                    err(113);
                END;
    sfProcTyp:
                BEGIN
                  IF ynode.clas = Nproc THEN
                    CheckProc(x, ynode.obj)
                  ELSE IF (x = y) OR (g = sfNilTyp) THEN (* ok *)
                  ELSE
                    err(113);
                END;
    sfNoTyp, sfNilTyp:  err(113);
    sfComp:
                BEGIN
                  OPT.MarkType(x);
                  IF x.comp = csStaticArr THEN BEGIN
                    IF (ynode.clas = Nconst) AND (g = sfChar) THEN BEGIN
                      CharToString(ynode);
                      y := ynode.typ;
                      g := sfString;
                    END;
                    IF x = y THEN (* ok *)
                    ELSE IF (ynode.typ.form=sfPointer) AND (x=ynode.typ.BaseTyp) THEN (* ok *)
                    ELSE IF (g = sfString) AND (x.BaseTyp = OPT.chartyp) THEN BEGIN(*check length of string*)
                      IF ynode.conval^.intval2 > x.n THEN err(114);
                    END ELSE
                      err(113);
                  END ELSE IF (x.comp IN [csSDynArr, csDynArr]) THEN BEGIN
                    IF x <> y THEN err(113);
                  END ELSE IF x.comp = csRecord THEN BEGIN
                    IF x = y THEN (* ok *)
                    ELSE IF y.comp = csRecord THEN BEGIN
                      q := y.BaseTyp;
                      WHILE (q <> NIL) AND (q <> x) AND (q <> OPT.undftyp) DO q := q.BaseTyp;
                      IF q = NIL THEN err(113);
                    END ELSE
                      err(113);
                  END ELSE (*DynArr*)
                    err(113);
                END;
  END ;
  IF (ynode.clas = Nconst) AND (g < f)
  AND (g IN [sfSInt..sfReal]) AND (f IN [sfInt..sfLReal]) THEN
    Convert(ynode, x);
END;
	
PROCEDURE CheckLeaf(x: OPT.Nodes; dynArrToo: BOOLEAN);
VAR
  obj: OPT.Objects;
BEGIN
  IF (x.clas = Nmop) AND (x.subcl = yval) THEN x := x.left;
  IF x.clas = Nguard THEN x := x.left;	(* skip last (and unique) guard *)
  IF (x.clas = Nvar) AND (dynArrToo OR (x.typ.comp <> csOpenArr)) THEN BEGIN
    obj := x.obj;
    WHILE obj <> NIL DO BEGIN
      obj.leaf := FALSE;
      obj := obj.scope
    END;
  END;
END;

PROCEDURE StPar0(VAR par0: OPT.Nodes; fctno: INTEGER);	(* par0: first param of standard proc *)
VAR
  f: INTEGER;
  t, ptr, typ: OPT.Structs;
  x: OPT.Nodes;
BEGIN
  x := par0;
  f := x.typ.form;
  CASE fctno OF
    haltfn, shalt: (*HALT*)
              BEGIN
                IF (f IN intSet) AND (x.clas = Nconst) THEN BEGIN
                  IF (fctno = shalt) OR (OPM.MinHaltNr <= x.conval^.intval)
                  AND (x.conval^.intval <= OPM.MaxHaltNr) THEN
                    BindNodes(Ntrap, OPT.notyp, x, x)
                  ELSE
                    err(218);
                END ELSE
                  err(69);
                x.typ := OPT.notyp;
              END;
    typefn:
              IF (x.clas <> Ntype) OR (x.typ.comp <> csRecord)
              AND ((f <> sfPointer) OR (x.typ.BaseTyp.comp <> csRecord)) THEN
                err(53)
              ELSE
                MOp(ytype, x);
    newfn: (*NEW*)
              BEGIN
                typ := OPT.notyp;
                InitPar := NIL;
                IF NotVar(x) THEN
                  err(112)
                ELSE IF (f = sfPointer) OR (x.typ.comp = csDynArr) THEN BEGIN
                  IF OPM.NEWusingAdr THEN CheckLeaf(x, TRUE);
                  IF x.readonly THEN err(76);
                  f := x.typ.BaseTyp.comp;
                  IF (f IN [csRecord, csDynArr, csOpenArr, csStaticArr]) OR (x.typ.comp = csDynArr) THEN BEGIN
                    IF x.typ.comp = csDynArr THEN
                      typ := x.typ
                    ELSE IF f <> csRecord THEN
                      typ:=x.typ.BaseTyp;
                    t := x.typ;
                    ptr := NIL;	(* check if type needs and has a type desc *)
                    WHILE (t.form = sfPointer) OR (t.comp IN ArraySet) DO BEGIN
                      IF t.form = sfPointer THEN ptr := t;
                      t := t.BaseTyp
                    END;
                    IF (t.mno <> 0) AND (t.comp = csRecord) THEN BEGIN
                      IF (t.strobj.vis <> internal) OR (OPT.typeVisible IN t.strobj.flag) THEN
                        (*ok*)
                      ELSE IF (ptr <> NIL) AND (ptr.BaseTyp = t) AND (ptr.mno <> 0) AND (ptr.strobj.vis <> internal) OR (OPT.typeVisible IN ptr.strobj.flag) THEN
                        (*ok*)
                      ELSE
                        err(200);	(* invisible -> td not accessible *)
                    END;
                    OPT.MarkType(x.typ);
                    BindNodes(Nassign, OPT.notyp, x, NIL);
                    x.subcl := fctno;
                    IF (f = csRecord) AND (x.left.typ.BaseTyp.strobj <> NIL) THEN BEGIN	(* set the initialiser parameter list *)
                      (* Pre: typ(x) = POINTER TO RECORD *)
                      t := x.left.typ.BaseTyp;
                      WHILE (t<>NIL) AND (t.strobj.link2=NIL) DO t := t.BaseTyp;
                      IF t <> NIL THEN InitPar := t.strobj.link2 ELSE InitPar := NIL;
                      IF InitPar <> NIL THEN BEGIN
                        CopyAndSubst(par0, x.left);			(* make a copy of the object, this is the SELF for the call *)
                        IF InitPar.link.typ.comp = csRecord THEN		(* deref par0 *)
                          DeRef (par0);
                        par0.link := OPT.NewNode(Nproc);
                        par0.link.obj := InitPar;
                        par0.link.typ := InitPar.typ;
                        InitPar := InitPar.link.link;	(* parameter list, skip the SELF, the list is in reverse order *)
                        x.left.link := par0;
                      END;
                    END;
                  END ELSE
                    err(111);
                END ELSE
                  err(111);
                x.typ := typ
              END;
    absfn: (*ABS*)  MOp(vabs, x);
    capfn: (*CAP*)  MOp(vcap, x);
    ordfn: (*ORD*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF f IN [sfByte, sfChar] THEN
                  Convert(x, OPT.inttyp)
                ELSE
                  err(111);
                x.typ := OPT.inttyp;
              END;
    entierfn: (*ENTIER*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF f IN realSet THEN
                  Convert(x, OPT.linttyp)
                ELSE
                  err(111);
                x.typ := OPT.linttyp;
              END;
    oddfn: (*ODD*) MOp(vodd, x);
    minfn: (*MIN*)
              BEGIN
                IF x.clas = Ntype THEN BEGIN
                  CASE f OF
                    sfBool :  x := NewBoolConst(FALSE);
                    sfChar :
                              BEGIN
                                x := NewIntConst(0);
                                x.typ := OPT.chartyp;
                              END;
                    sfSInt :  x := NewIntConst(MinSInt);
                    sfInt  :  x := NewIntConst(MinInt);
                    sfLInt :  x := NewIntConst(MinLInt);
                    sfSet  :
                              BEGIN
                                x := NewIntConst(0);
                                x.typ := OPT.inttyp;
                              END;
                    sfReal :  x := NewRealConst(OPM.MinReal, OPT.realtyp);
                    sfLReal:  x := NewRealConst(OPM.MinLReal, OPT.lrltyp);
                  ELSE
                    err(111)
                  END
                END ELSE
                  err(110);
              END;
    maxfn: (*MAX*)
              BEGIN
                IF x.clas = Ntype THEN BEGIN
                  CASE f OF
                    sfBool :  x := NewBoolConst(TRUE);
                    sfChar :
                              BEGIN
                                x := NewIntConst($0FF);
                                x.typ := OPT.chartyp;
                              END;
                    sfSInt :  x := NewIntConst(MaxSInt);
                    sfInt  :  x := NewIntConst(MaxInt);
                    sfLInt :  x := NewIntConst(MaxLInt);
                    sfSet  :
                              BEGIN
                                x := NewIntConst(MaxSet);
                                x.typ := OPT.inttyp;
                              END;
                    sfReal :  x := NewRealConst(MaxReal, OPT.realtyp);
                    sfLReal:  x := NewRealConst(MaxLReal, OPT.lrltyp);
                  ELSE
                    err(111);
                  END;
                END ELSE
                  err(110);
              END;
    chrfn: (*CHR*)
              IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                err(126)
              ELSE IF f IN [sfUndef, sfByte, sfSInt..sfLInt] THEN
                Convert(x, OPT.chartyp)
              ELSE BEGIN
                err(111);
                x.typ := OPT.chartyp;
              END;
    shortfn: (*SHORT*)
              IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                err(126)
              ELSE IF f = sfInt THEN
                Convert(x, OPT.sinttyp)
              ELSE IF f = sfLInt THEN
                Convert(x, OPT.inttyp)
              ELSE IF f = sfLReal THEN
                Convert(x, OPT.realtyp)
              ELSE
                err(111);
    longfn: (*LONG*)
              IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                err(126)
              ELSE IF f = sfSInt THEN
                Convert(x, OPT.inttyp)
              ELSE IF f = sfInt THEN
                Convert(x, OPT.linttyp)
              ELSE IF f = sfReal THEN
                Convert(x, OPT.lrltyp)
              ELSE IF f = sfChar THEN
                Convert(x, OPT.linttyp)
              ELSE
                err(111);
    incfn, decfn: (*INC, DEC*)
              IF NotVar(x) THEN
                err(112)
              ELSE IF  NOT (f IN intSet) THEN
                err(111)
              ELSE IF x.readonly THEN
                err(76);
    inclfn, exclfn: (*INCL, EXCL*)
              IF NotVar(x) THEN
                err(112)
              ELSE IF x.typ <> OPT.settyp THEN BEGIN
                err(111);
                x.typ := OPT.settyp
              END ELSE IF x.readonly THEN
                err(76);
    lenfn: (*LEN*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN err(126);
                IF x.typ.form=sfPointer THEN DeRef(x);
                IF NOT (x.typ.comp IN ArraySet) THEN err(131);
              END;
    copyfn: (*COPY*)
              BEGIN
                IF (x.clas = Nconst) AND (f = sfChar) THEN BEGIN
                  CharToString(x);
                  f := sfString;
                END ;
                IF (x.typ.form=sfPointer) THEN DeRef(x);
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF ( NOT (x.typ.comp IN ArraySet) OR (x.typ.BaseTyp.form <> sfChar))
                AND (f <> sfString) THEN err(111);
              END;
    ashfn: (*ASH*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF f IN intSet THEN BEGIN
                  IF f <> sfLInt THEN Convert(x, OPT.linttyp);
                END ELSE BEGIN
                  err(111);
                  x.typ := OPT.linttyp;
                END
              END;
    adrfn: (*SYSTEM.ADR*)
              BEGIN
                CheckLeaf(x, FALSE);
                IF (x.obj <> NIL) AND (x.obj.mode = sfTProc) THEN
                  err(126)
                ELSE
                  MOp(yadr, x);
              END;
    sizefn: (*SIZE*)	(* SIZE doesn't work for SDynArr too *)
              BEGIN
                IF (f=sfPointer)AND(x.typ.BaseTyp.comp IN [csStaticArr, csDynArr, csOpenArr]) THEN
                  err(111)
                ELSE IF x.typ.comp = csDynArr THEN
                  err(111);
                IF x.clas <> Ntype THEN BEGIN
                  err(110);
                  x := NewIntConst(1);
                END ELSE IF (f IN [sfByte..sfSet, sfPointer, sfProcTyp])
                OR (x.typ.comp=csRecord) OR (x.typ.comp=csStaticArr) THEN BEGIN
                  typSize(x.typ, FALSE);
                  OPT.MarkType(x.typ);
                  x := NewIntConst(x.typ.size)
                END ELSE BEGIN
                  err(111);
                  x := NewIntConst(1);
                END
              END;
    ccfn: (*SYSTEM.CC*) MOp(ycc, x);
    lshfn, rotfn: (*SYSTEM.LSH, SYSTEM.ROT*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF  NOT (f IN intSet + [sfByte, sfChar, sfSet]) THEN
                  err(111);
              END;
    getfn, putfn, bitfn, movefn,
    get8fn..get32fn, put8fn..put32fn: (*SYSTEM.GET, SYSTEM.PUT, SYSTEM.BIT, SYSTEM.MOVE*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF (x.clas = Nconst) AND (f IN [sfSInt, sfInt]) THEN
                  Convert(x, OPT.linttyp)
                ELSE IF (f=sfPointer) AND (x.typ.BaseTyp.comp IN [csStaticArr, csDynArr, csOpenArr]) THEN BEGIN
                  err(111);
                  x.typ := OPT.linttyp;
                END ELSE IF NOT (f IN [sfLInt, sfPointer]) THEN BEGIN
                  err(111);
                  x.typ := OPT.linttyp;
                END;
                IF (get8fn<=fctno) AND (fctno<=get32fn) THEN MOp(fctno-get8fn+yget8,x);
              END;
    getrfn, putrfn: (*SYSTEM.GETREG, SYSTEM.PUTREG*)
              BEGIN
                IF (f IN intSet) AND (x.clas = Nconst) THEN BEGIN
                  IF (x.conval^.intval < OPM.MinRegNr) OR (x.conval^.intval > OPM.MaxRegNr) THEN err(220);
                END ELSE
                  err(69);
              END;
    valfn: (*SYSTEM.VAL*)
              BEGIN
                IF x.clas <> Ntype THEN
                  err(110)
                ELSE IF (f IN [sfUndef, sfString, sfNoTyp]) OR (x.typ.comp IN [csSDynArr, csOpenArr]) THEN
                  err(111)
              END;
    sysnewfn: (*SYSTEM.NEW*)
              BEGIN
                IF NotVar(x) THEN
                  err(112)
                ELSE IF f = sfPointer THEN BEGIN
                  IF OPM.NEWusingAdr THEN CheckLeaf(x, TRUE);
                END ELSE
                  err(111);
              END;
    assertfn: (*ASSERT*)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN BEGIN
                  err(126);
                  x := NewBoolConst(FALSE);
                END ELSE IF f <> sfBool THEN BEGIN
                  err(120);
                  x := NewBoolConst(FALSE);
                END ELSE
                  MOp(vnot, x);
              END;
    poutfn, pinfn:		(* SYSTEM.PORTOUT, SYSTEM.PORTIN *)
              BEGIN
                IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                  err(126)
                ELSE IF (x.clas = Nconst) AND (f = sfLInt) THEN BEGIN
                  IF (x.conval^.intval < 0) OR (x.conval^.intval > 65535) THEN OPM.err(203);
                  x.typ := OPT.inttyp
                END ELSE IF (f IN [sfLInt, sfSInt]) THEN
                  Convert(x, OPT.inttyp)
                ELSE IF (f IN [sfInt]) THEN
                ELSE BEGIN
                  err(111);
                  x.typ := OPT.inttyp;
                END;
              END;
    awaitfn:  IF f <> sfBool THEN err(120);
  ELSE
    err(64)
  END ;
  par0 := x;
END;

PROCEDURE StPar1(VAR par0: OPT.Nodes; x: OPT.Nodes; fctno: SHORTINT);	(* x: second parameter of standard proc *)
VAR
  f, L: INTEGER;
  typ: OPT.Structs;
  p, t: OPT.Nodes;
  i: LONGINT;
		
  FUNCTION NewOp(Aclass, subcl: SHORTINT; left, right: OPT.Nodes): OPT.Nodes;
  VAR
    node: OPT.Nodes;
  BEGIN
    node := OPT.NewNode(Aclass);
    node.subcl := subcl;
    node.left := left;
    node.right := right;
    RESULT:= node;
  END;
		
BEGIN
  p := par0;
  f := x.typ.form;
  i:=0;
  CASE fctno OF
    incfn, decfn: (*INC DEC*)
                    IF (x.clas = Ntype) OR (x.clas = Nproc) THEN BEGIN
                      err(126);
                      p.typ := OPT.notyp;
                    END ELSE BEGIN
                      IF x.typ <> p.typ THEN BEGIN
                        IF (f IN intSet) AND (f < p.typ.form) THEN
                          Convert(x, p.typ)
                        ELSE
                          err(111);
                      END;
                      p := NewOp(Nassign, fctno, p, x);
                      p.typ := OPT.notyp
                    END;
    inclfn, exclfn: (*INCL, EXCL*)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN intSet THEN BEGIN
                        IF (x.clas = Nconst) AND ((0 > x.conval^.intval)
                        OR (x.conval^.intval > MaxSet)) THEN
                          err(202);
                        p := NewOp(Nassign, fctno, p, x);
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    lenfn: (*LEN*)
                    BEGIN
                      IF  NOT (f IN intSet) OR (x.clas <> Nconst) THEN
                        err(69)
                      ELSE IF f = sfSInt THEN BEGIN
                        L := x.conval^.intval;
                        typ := p.typ;
                        WHILE (L > 0) AND (typ.comp IN ArraySet) DO BEGIN
                          typ := typ.BaseTyp;
                          DEC(L)
                        END;
                        IF (L <> 0) OR NOT (typ.comp IN ArraySet) THEN
                          err(132)
                        ELSE BEGIN
                          x.obj := NIL;
                          IF (typ.comp IN [csDynArr, csOpenArr]) THEN BEGIN
                            WHILE p.clas = Nindex DO BEGIN
                              p := p.left;
                              INC(x.conval^.intval);
                            END;	(* possible side effect ignored *)
                            p := NewOp(Ndop, vlen, p, x);
                            p.typ := OPT.linttyp;
                          END ELSE IF typ.comp=csSDynArr THEN BEGIN
                            p:=NewLeaf(typ.link);
                            p.typ := OPT.linttyp;
                          END ELSE BEGIN
                            p := x;
                            p.conval^.intval := typ.n;
                            SetIntType(p);
                          END;
                        END;
                      END ELSE
                        err(132);
                    END;
    copyfn: (*COPY*)
                    BEGIN
                      IF (x.typ.form=sfPointer) THEN DeRef(x);
                      IF NotVar(x) THEN
                        err(112)
                      ELSE IF (x.typ.comp IN ArraySet) AND (x.typ.BaseTyp.form = sfChar) THEN BEGIN
                        IF x.readonly THEN err(76);
                        t := x;
                        x := p;
                        p := t;
                        p := NewOp(Nassign, copyfn, p, x);
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    ashfn: (*ASH*)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN intSet THEN BEGIN
                        IF (p.clas = Nconst) AND (x.clas = Nconst) THEN BEGIN
                          IF (-maxExp > x.conval^.intval) OR (x.conval^.intval > maxExp) THEN BEGIN
                            err(208);
                            p.conval^.intval := 1;
                          END ELSE IF x.conval^.intval >= 0 THEN BEGIN
                            IF ABS(p.conval^.intval) <= MAX(_LONGINTS) DIV ASH(1, x.conval^.intval) THEN
                              p.conval^.intval := p.conval^.intval * ASH(1, x.conval^.intval)
                            ELSE BEGIN
                              err(208);
                              p.conval^.intval := 1;
                            END
                          END ELSE
                            p.conval^.intval := ASH(p.conval^.intval, x.conval^.intval);
                          p.obj := NIL;
                        END ELSE IF (x.clas = Nconst) AND (x.conval^.intval = 0) THEN		(*skip, p is not changed!*)
                        ELSE BEGIN
                          p := NewOp(Ndop, vash, p, x);
                          p.typ := OPT.linttyp;
                        END
                      END ELSE
                        err(111);
                    END;
    newfn: (*NEW(p, x...)*)
                    BEGIN
                      IF InitPar <> NIL THEN BEGIN
                          FNParam(x, InitPar);
                          InitPar := InitPar.link;
                          x.link := p.left.link;
                          p.left.link := x
                      END ELSE IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF p.typ.comp IN [csDynArr, csOpenArr] THEN BEGIN
                        IF f IN intSet THEN BEGIN
                          IF (x.clas = Nconst) AND ((x.conval^.intval < 0)
                          OR (x.conval^.intval > OPM.MaxIndex)) THEN err(63);
                        END ELSE
                          err(111);
                        p.right := x;
                        p.typ := p.typ.BaseTyp;
                      END ELSE
                        err(64);
                    END;
    lshfn, rotfn: (*SYSTEM.LSH, SYSTEM.ROT*)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF  NOT (f IN intSet) THEN
                        err(111)
                      ELSE BEGIN
                        IF fctno = lshfn THEN
                          p := NewOp(Ndop, ylsh, p, x)
                        ELSE
                          p := NewOp(Ndop, yrot, p, x);
                        p.typ := p.left.typ
                      END;
                    END;
    getfn, putfn, poutfn, pinfn: (*SYSTEM.GET, SYSTEM.PUT *)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN [sfUndef..sfSet, sfNilTyp, sfPointer, sfProcTyp] THEN BEGIN
                        IF (fctno = getfn) OR (fctno = getrfn) OR (fctno = pinfn) THEN BEGIN
                          IF NotVar(x) THEN err(112);
                          t := x;
                          x := p;
                          p := t
                        END ELSE IF x.clas = Nconst THEN
                          err(-306);
                        p := NewOp(Nassign, fctno, p, x);
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    put8fn:
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN [sfUndef..sfLInt] THEN BEGIN
                        IF f IN [sfInt..sfLInt] THEN FNVal(x, OPT.sinttyp);
                        p := NewOp(Nassign, putfn, p, x);
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    put16fn:
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF (f IN [sfUndef, sfSInt..sfLInt]) THEN BEGIN
                        IF f IN [sfSInt, sfLInt] THEN Convert(x, OPT.inttyp);
                        p := NewOp(Nassign, putfn, p, x)
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    put32fn:
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF (f IN [sfUndef, sfSInt..sfLInt, sfSet, sfPointer, sfProcTyp, sfNilTyp]) THEN BEGIN
                        IF f IN [sfSInt, sfInt] THEN Convert(x, OPT.linttyp);
                        p := NewOp(Nassign, putfn, p, x)
                      END ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    getrfn, putrfn: (*SYSTEM.GETREG, SYSTEM.PUTREG*)
                    BEGIN
                      IF p.conval <> NIL THEN BEGIN
                        i := p.conval^.intval;
                        p.conval^.intval := i MOD 8;
                      END;
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF (0<=i) AND (i < 8) AND  NOT (f IN [sfUndef..sfReal, sfSet, sfNilTyp, sfPointer, sfProcTyp]) THEN err(111)		(*old definition*)
                      ELSE IF (8<=i) AND (i < 16) AND  NOT (f IN [sfLInt, sfReal, sfSet, sfPointer, sfProcTyp]) THEN err(111)		(*EAX .. EDI*)
                      ELSE IF (16<=i) AND (i < 24) AND  NOT (f IN [sfInt]) THEN err(111)		(*AX .. DI*)
                      ELSE IF (24<=i) AND (i < 32) AND  NOT (f IN [sfByte, sfBool, sfChar, sfSInt]) THEN err(111)		(*AL .. BH*)
                      ELSE BEGIN
                        IF fctno = getrfn THEN BEGIN
                          IF NotVar(x) THEN err(112);
                          t := x;
                          x := p;
                          p := t
                        END ELSE IF (0<=i) AND (i < 8) AND (x.clas = Nconst) THEN
                          err(-306);
                        p := NewOp(Nassign, fctno, p, x)
                      END ;
                      p.typ := OPT.notyp;
                    END;
    bitfn: (*SYSTEM.BIT*)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN intSet THEN
                        p := NewOp(Ndop, ybit, p, x)
                      ELSE
                        err(111);
                      p.typ := OPT.booltyp;
                    END;
    valfn: (*SYSTEM.VAL*)	(* type is changed without considering the byte ordering on the target machine *)
                    BEGIN
                      FNVal(x, p.typ);
                      p := x;
                    END;
    sysnewfn: (*SYSTEM.NEW*)
                    BEGIN
                      IF (p.typ.form=sfPointer) AND (p.typ.BaseTyp.comp IN ArraySet) THEN
                        err(111)
                      ELSE IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF f IN intSet THEN
                        p := NewOp(Nassign, sysnewfn, p, x)
                      ELSE
                        err(111);
                      p.typ := OPT.notyp;
                    END;
    movefn: (*SYSTEM.MOVE*)
                    BEGIN
                      IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
                        err(126)
                      ELSE IF (x.clas = Nconst) AND (f IN [sfSInt, sfInt]) THEN
                        Convert(x, OPT.linttyp)
                      ELSE IF  NOT (f IN [sfLInt, sfPointer]) THEN BEGIN
                        err(111);
                        x.typ := OPT.linttyp
                      END ;
                      p.link := x;
                    END;
    assertfn: (*ASSERT*)
                    BEGIN
                      IF (f IN intSet) AND (x.clas = Nconst) THEN BEGIN
                        IF (OPM.MinHaltNr <= x.conval^.intval) AND (x.conval^.intval <= OPM.MaxHaltNr) THEN BEGIN
                          BindNodes(Ntrap, OPT.notyp, x, x);
                          x.conval := OPT.NewConst();
                          x.conval^.intval := OPM.errpos.CodePos;
                          Construct(Nif, p, x);
                          p.conval := OPT.NewConst();
                          p.conval^.intval := OPM.errpos.CodePos;
                          Construct(Nifelse, p, NIL);
                          OptIf(p);
                          IF p = NIL THEN	(* ASSERT(TRUE) *)
                          ELSE IF p.clas = Ntrap THEN err(99)
                          ELSE p.subcl := assertfn;
                        END ELSE
                          err(218)
                      END ELSE
                        err(69);
                    END;
  ELSE
    err(64)
  END ;
  par0 := p
END;

PROCEDURE StParN(VAR par0: OPT.Nodes; x: OPT.Nodes; fctno, n: INTEGER);	(* x: n+1-th param of standard proc *)
VAR
  node: OPT.Nodes;
  f: INTEGER;
  p: OPT.Nodes;
BEGIN
  p := par0;
  f := x.typ.form;
  IF fctno = newfn THEN BEGIN(*NEW(p, ..., x...*)
    IF InitPar <> NIL THEN BEGIN
      FNParam(x, InitPar);
      InitPar := InitPar.link;
      x.link := p.left.link;
      p.left.link := x;
    END ELSE IF  NOT (p.typ.comp IN [csDynArr, csOpenArr]) THEN
      err(64)
    ELSE IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
      err(126)
    ELSE IF f IN intSet THEN BEGIN
      IF (x.clas = Nconst) AND ((x.conval^.intval <0)
      OR (x.conval^.intval > OPM.MaxIndex)) THEN err(63);
      node := p.right;
      WHILE node.link <> NIL DO node := node.link;
      node.link := x;
      p.typ := p.typ.BaseTyp;
    END ELSE
      err(111);
  END ELSE IF (fctno = movefn) AND (n = 2) THEN BEGIN(*SYSTEM.MOVE*)
    IF (x.clas = Ntype) OR (x.clas = Nproc) THEN
      err(126)
    ELSE IF f IN intSet THEN BEGIN
      node := OPT.NewNode(Nassign);
      node.subcl := movefn;
      node.right := p;
      node.left := p.link;
      p.link := x;
      p := node
    END ELSE
      err(111);
    p.typ := OPT.notyp
  END ELSE
    err(64);
  par0 := p
END;

PROCEDURE StFct(VAR par0: OPT.Nodes; fctno: SHORTINT; parno: INTEGER);
VAR
  dim: INTEGER;
  x, p, r: OPT.Nodes;
  obj: OPT.Objects;
  typ: OPT.Structs;
BEGIN
  x:=NIL;
  obj:=NIL;
  typ:=NIL;
  p := par0;
  IF (fctno <= ashfn) OR (fctno = shalt) THEN BEGIN
    IF fctno = newfn THEN BEGIN
      IF parno < 1 THEN
        err(65)
      ELSE IF p.typ <> OPT.notyp THEN BEGIN
        IF p.typ.comp IN [csDynArr, csOpenArr] THEN err(65);
        p.typ := OPT.notyp
      END ELSE BEGIN
        IF InitPar <> NIL THEN BEGIN
          InitPar := NIL;
          err(65)
        END;
        x := NIL;
        IF p.left = NIL THEN EXIT;	(* error in StPar0 *)
        IF p.left.link <> NIL THEN BEGIN
          p := p.left.link;
          WHILE p <> NIL DO BEGIN	(* reverse the list in p.left.link *)
            r := p.link;
            p.link := x;
            x := p;
            p := r
          END;
          r := x.link; x.link := NIL;	(* parameter list *)
          BindNodes(Ncall, OPT.notyp, x, r); x.obj := x.left.obj.link;
          p := par0; p.left.link := x
        END;
        (* insert reference to the body *)
        IF (p.left <> NIL) AND (p.left.typ <> NIL)
        AND (p.left.typ.BaseTyp <> NIL) THEN
          typ := p.left.typ.BaseTyp;
        r := NIL;
        WHILE (typ <> NIL) AND (typ.comp = csRecord) DO BEGIN
          IF (typ.strobj <> NIL) AND (hasBody IN typ.strobj.conval^.setval) THEN BEGIN
            x := NIL;
            Construct(Nproc, x, NIL);
            x.obj := typ.strobj;
            x.link := r; r := x;
          END;
          typ := typ.BaseTyp
        END;
        p.right := r
      END
    END ELSE IF (fctno <= sizefn) OR (fctno = shalt) THEN BEGIN(* 1 param *)
      IF parno < 1 THEN err(65);
    END ELSE BEGIN(* more than 1 param *)
      IF ((fctno = incfn) OR (fctno = decfn)) AND (parno = 1) THEN BEGIN(*INC, DEC*)
        BindNodes(Nassign, OPT.notyp, p, NewIntConst(1));
        p.subcl := fctno;
        p.right.typ := p.left.typ
      END ELSE IF (fctno = lenfn) AND (parno = 1) THEN BEGIN(*LEN*)
        IF p.typ.comp IN [csDynArr, csOpenArr] THEN BEGIN
          dim := 0;
          WHILE p.clas = Nindex DO BEGIN
            p := p.left;
            INC(dim)
          END ;	(* possible side effect ignored *)
          BindNodes(Ndop, OPT.linttyp, p, NewIntConst(dim));
          p.subcl := vlen;
        END ELSE IF p.typ.comp=csSDynArr THEN BEGIN
          p:=NewLeaf(p.typ.link);
          p.typ := OPT.linttyp
        END ELSE
          p := NewIntConst(p.typ.n);
      END ELSE IF parno < 2 THEN
        err(65);
    END;
  END ELSE IF fctno = awaitfn THEN BEGIN
    IF AwaitIF THEN	BEGIN(*Await Call: IF  NOT cond THEN AWAIT(cond) END*)
      x := p;
      BindNodes(Nassign, OPT.notyp, x, x.link);
      x.left.link := NIL;
      x.subcl := awaitfn;
      x.conval := OPT.NewConst();
      x.conval^.intval := OPM.errpos.CodePos;
        (*Create the condition*)
      PrepCall(p, obj);
      Call(p, NIL, obj);
      MOp(vnot, p);
        (*build if*)
      Construct(Nif, p, x);
      p.conval := OPT.NewConst();
      p.conval^.intval := OPM.errpos.CodePos;
      Construct(Nifelse, p, NIL);
      OptIf(p);
    END ELSE BEGIN
      BindNodes(Nassign, OPT.notyp, p, p.link);
      p.left.link := NIL;
      p.subcl := awaitfn;
      p.conval := OPT.NewConst();
      p.conval^.intval := OPM.errpos.CodePos
    END
  END ELSE IF fctno = assertfn THEN BEGIN
    IF parno = 1 THEN BEGIN
      x := NIL;
      BindNodes(Ntrap, OPT.notyp, x, NewIntConst(AssertTrap));
      x.conval := OPT.NewConst();
      x.conval^.intval := OPM.errpos.CodePos;
      Construct(Nif, p, x);
      p.conval := OPT.NewConst();
      p.conval^.intval := OPM.errpos.CodePos;
      Construct(Nifelse, p, NIL);
      OptIf(p);
      IF p = NIL THEN	(* ASSERT(TRUE) *)
      ELSE IF p.clas = Ntrap THEN err(99)
      ELSE p.subcl := assertfn;
    END ELSE IF parno < 1 THEN
      err(65);
  END ELSE BEGIN(*SYSTEM*)
    IF (fctno = stifn) OR (fctno = clifn) THEN BEGIN
      p := NIL;
      Construct(Nassign, p, NIL);
      p.subcl := fctno
    END ELSE IF (fctno <> stifn) AND (fctno <> clifn) AND (parno < 1) OR
      (fctno <> stifn) AND (fctno <> clifn) AND (fctno > ccfn)
      AND (fctno < get8fn) AND (parno < 2) OR
      (fctno = movefn) AND (parno < 3) THEN err(65);
  END ;
  par0 := p
END;
	
PROCEDURE OpenArrParCheck(ftyp, atyp: OPT.Structs; fvarpar: BOOLEAN);
  VAR f: INTEGER;
BEGIN (* ftyp.comp = OpenArr *)
  f := atyp.comp;
  ftyp := ftyp.BaseTyp;
  atyp := atyp.BaseTyp;
  IF (*fvarpar AND*) (ftyp = OPT.bytetyp) THEN BEGIN(* ok, but ... *)	(* 2. Appendix C, 2nd paragraph *)
    IF NOT (f IN ArraySet) OR  NOT (atyp.form IN [sfByte..sfSInt]) THEN err(-301) (* ... warning 301 *)
  END ELSE IF f IN ArraySet THEN BEGIN
    IF ftyp.comp = csOpenArr THEN
      OpenArrParCheck(ftyp, atyp, fvarpar)
    ELSE IF ftyp <> atyp THEN BEGIN
      IF (ftyp.form = sfPointer) AND (atyp.form = sfPointer) THEN BEGIN
        ftyp := ftyp.BaseTyp;
        atyp := atyp.BaseTyp;
        IF (ftyp.comp=csOpenArr) AND (atyp.comp IN ArraySet) THEN
          OpenArrParCheck(ftyp, atyp, fvarpar)
        ELSE IF  NOT fvarpar AND (ftyp.comp = csRecord) AND (atyp.comp = csRecord) THEN BEGIN
          WHILE (ftyp <> atyp) AND (atyp <> NIL) AND (atyp <> OPT.undftyp) DO atyp := atyp.BaseTyp;
          IF atyp = NIL THEN err(113);
        END ELSE
          err(66);
      END ELSE
        err(66);
    END;
  END ELSE
    err(67);
END;

PROCEDURE CheckReceiver(VAR x: OPT.Nodes; fp: OPT.Objects);
BEGIN
  IF fp.typ.form = sfPointer THEN BEGIN
    IF x.clas = Nderef THEN
      x := x.left (*undo DeRef*)
    ELSE IF x.typ.form <> sfPointer THEN
      err(71)
  END
END;
	
PROCEDURE PrepCall(VAR x: OPT.Nodes; VAR fpar: OPT.Objects);
BEGIN
  IF (x.obj <> NIL) AND (x.obj.mode IN [omLProc, omXProc, omTProc, omCProc]) THEN BEGIN
    fpar := x.obj.link;
    IF x.obj.mode = omTProc THEN BEGIN
      CheckReceiver(x.left, fpar);
      fpar := fpar.link
    END;
  END ELSE IF (x.clas <> Ntype) AND (x.typ <> NIL) AND (x.typ.form = sfProcTyp) THEN
    fpar := x.typ.link
  ELSE BEGIN
    err(121);
    fpar := NIL;
    x.typ := OPT.undftyp
  END
END;

PROCEDURE FNParam(VAR ap: OPT.Nodes; fp: OPT.Objects);
VAR
  q: OPT.Structs;
BEGIN
  IF fp.typ.form <> sfUndef THEN BEGIN
    IF (fp.typ.sysflag = 0) AND (ap.typ.sysflag = notag) THEN err(59);
    IF (fp.typ.comp = csOpenArr) AND (fp.typ.BaseTyp = OPT.bytetyp)
    AND (ap.typ.form = sfPointer) THEN
      err(113)
    ELSE IF (ap.typ.form = sfNilTyp) AND OPT.SYSimported THEN BEGIN
      IF (fp.typ.form = sfPointer) OR (fp.typ.form = sfProcTyp)
      OR (fp.mode = omVarPar) OR (fp.typ.sysflag = notag) THEN
      ELSE err(113);
    END ELSE IF fp.mode = omVarPar THEN BEGIN
      IF NotVar(ap) THEN
        err(122)
      ELSE
        CheckLeaf(ap, FALSE);
      IF ap.readonly THEN err(76);
      IF fp.typ.comp = csOpenArr THEN
        OpenArrParCheck(fp.typ, ap.typ, TRUE)
      ELSE IF (fp.typ.comp = csRecord) AND (ap.typ.comp = csRecord) THEN BEGIN
        q := ap.typ;
        OPT.MarkType(q);
        WHILE (q <> fp.typ) AND (q <> NIL) AND (q <> OPT.undftyp) DO q := q.BaseTyp;
        IF q = NIL THEN err(111);
      END ELSE IF (fp.typ = OPT.ptrtyp) AND (ap.typ.form = sfPointer) THEN (* ok *)
      ELSE IF (ap.typ <> fp.typ) AND  NOT ((fp.typ.form = sfByte)
      AND (ap.typ.form IN [sfChar, sfSInt])) THEN err(123)
      ELSE IF (fp.typ.form = sfPointer) AND (ap.clas = Nguard) THEN err(123);
    END ELSE IF fp.typ.comp = csOpenArr THEN BEGIN
      IF (ap.clas = Nconst) AND (ap.typ.form = sfChar) THEN CharToString(ap);
      IF (ap.typ.form = sfString) AND (fp.typ.BaseTyp.form = sfChar) THEN (* ok *)
      ELSE IF (ap.clas >= Nconst) AND (ap.clas<>Ncall) THEN err(59)
      ELSE OpenArrParCheck(fp.typ, ap.typ, FALSE);
    END ELSE
      CheckAssign(fp.typ, ap);
  END;
END;
	
PROCEDURE StaticLink(dlev: SHORTINT);
VAR
  scope: OPT.Objects;
BEGIN
  scope := OPT.topScope;
  WHILE dlev > 0 DO BEGIN
    DEC(dlev);
    INCL(scope.link.conval^.setval, slNeeded);
    scope := scope.left
  END
END;

PROCEDURE Call(VAR x: OPT.Nodes; apar: OPT.Nodes; fp: OPT.Objects);
VAR
  typ: OPT.Structs;
  p: OPT.Nodes;
  lev: SHORTINT;
BEGIN
  IF x.clas = Nproc THEN BEGIN
    typ := x.typ;
    lev := x.obj.mnolev;
    IF lev > 0 THEN StaticLink(OPT.topScope.mnolev-lev);
    IF x.obj.mode = omIProc THEN err(121);
  END ELSE IF (x.clas = Nfield) AND (x.obj.mode = omTProc) THEN BEGIN
    typ := x.typ;
    x.clas := Nproc;
    p := x.left;
    x.left := NIL;
    p.link := apar;
    apar := p;
    fp := x.obj.link
  END ELSE
    typ := x.typ.BaseTyp;
  BindNodes(Ncall, typ, x, apar);
  x.obj := fp;
  x.subcl := 0  (* 0 = no assign call *)
END;
	
PROCEDURE CopyAndSubst(VAR new: OPT.Nodes; old: OPT.Nodes);
BEGIN
  IF old = NIL THEN BEGIN
    new := NIL;
    EXIT;
  END ELSE IF (old.obj <> NIL) AND (old.obj.link2 <> NIL)
  AND ((old.obj.mode = omVar) OR (old.obj.mode = omVarPar)) THEN BEGIN
    new := NewLeaf(old.obj.link2);
    new.conval := old.conval;
    IF (new.clas = Nfixup) AND (old.obj.link2.mnolev <= 0) THEN err(261);
  END ELSE BEGIN
    new := OPT.NewNode(old.clas);
    new := old;
  END;
  IF (old.clas = 29) AND (old.conval^.intval = 0) THEN BEGIN	(*imported inline, set errpos*)
    new.conval := OPT.NewConst();
    new.conval^ := old.conval^;
    new.conval^.intval := OPM.errpos.CodePos;
  END;
  CopyAndSubst(new.left, old.left);
  CopyAndSubst(new.right, old.right);
  CopyAndSubst(new.link, old.link)
END;

PROCEDURE Lock(VAR x: OPT.Nodes; self: OPT.Objects; excl: BOOLEAN);
VAR
  n: OPT.Nodes;
BEGIN
  IF self<>NIL THEN BEGIN
    BindNodes(Nassign, OPT.notyp, x, NewLeaf(self));
    x.subcl := lockfn;
    x.obj := self;
    n := NewBoolConst (excl);
    x.right.link := n;
  END
END;

PROCEDURE Enter(VAR procdec: OPT.Nodes; stat: OPT.Nodes; proc: OPT.Objects);
VAR
  x: OPT.Nodes;
BEGIN
  x := OPT.NewNode(Nenter);
  x.typ := OPT.notyp;
  x.obj := proc;
  x.left := procdec;
  x.right := stat;
  InitAppend(x.right);
  procdec := x;
END;
	
PROCEDURE Return(VAR x: OPT.Nodes; proc: OPT.Objects);
VAR
  node: OPT.Nodes;
BEGIN
  IF proc = NIL THEN BEGIN(* RESULT:= from module *)
    IF x <> NIL THEN err(124);
  END ELSE BEGIN
    IF x <> NIL THEN BEGIN
      IF proc.typ.comp = csOpenArr THEN BEGIN		(* same as Param *)
        IF x.typ.form=sfPointer THEN DeRef(x);
        IF (x.clas = Nconst) AND (x.typ.form = sfChar) THEN CharToString(x);
        IF (x.typ.form = sfString) AND (proc.typ.BaseTyp.form = sfChar) THEN (* ok *)
        ELSE IF (x.clas >= Nconst) AND (x.clas<>Ncall) THEN
          err(59)
        ELSE
          OpenArrParCheck(proc.typ, x.typ, FALSE);
      END ELSE
        CheckAssign(proc.typ, x);
    END ELSE IF proc.typ <> OPT.notyp THEN
      err(124);
  END;
  node := OPT.NewNode(NReturn);
  node.typ := OPT.notyp;
  node.obj := proc;
  node.left := x;
  x := node;
END;

PROCEDURE Assign(VAR x: OPT.Nodes; y: OPT.Nodes);	(* x := y *)
VAR
  z: OPT.Nodes;
  struct: BOOLEAN;
BEGIN
  z:=NIL;
  struct := x.typ.form = sfComp;
  IF x.clas >= Nconst THEN err(56);
(*		IF (x.typ.comp=DynArr) AND (x.class > Nfield) THEN err(113) END;	*)
  CheckAssign(x.typ, y);
  IF x.readonly THEN err(76);
  OPT.MarkType(x.typ);
  IF x.typ.comp = csRecord THEN BEGIN
    IF x.clas = Nguard THEN
      z := x.left
    ELSE
      z := x;
    IF (z.clas = Nderef) AND (z.left.clas = Nguard) THEN
      z.left := z.left.left;	(* skip guard before dereferencing *)
    IF (x.typ.strobj <> NIL) AND ((z.clas = Nderef) OR (z.clas = Nvarpar)) THEN BEGIN
      IF x.typ.sysflag <> notag THEN
        BindNodes(Neguard, x.typ, z, NIL);
      x := z
    END
  END ELSE IF (x.typ.comp IN [csStaticArr, csSDynArr]) AND (x.typ.BaseTyp = OPT.chartyp) AND
      (y.typ.form = sfString) AND (y.conval^.intval2 = 1) THEN	BEGIN(* replace array := "" with array[0] := 0X *)
    y.typ := OPT.chartyp;
    y.conval^.intval := 0;
    Index(x, NewIntConst(0))
  END ;
  BindNodes(Nassign, OPT.notyp, x, y);
  x.subcl := assignfn;
  IF struct AND (y.clas = Ncall) THEN y.subcl := 1;  (* 1 = assign call *)
END;
	
PROCEDURE Inittd(VAR inittd, last: OPT.Nodes; typ: OPT.Structs);
VAR
  node: OPT.Nodes;
BEGIN
  node := OPT.NewNode(Ninittd);
  node.typ := typ;
  node.conval := OPT.NewConst();
  node.conval^.intval := typ.txtpos.CodePos;
  IF inittd = NIL THEN
    inittd := node
  ELSE
    last.link := node;
  last := node;
END;

PROCEDURE OPBBegin;
BEGIN
	maxExp := log(MAX(_LONGINTS) DIV 2 + 1);
  maxExp := exp;
	verify:=NIL;
  Vverify:=FALSE;
END;

END.
