UNIT OPE;

INTERFACE

USES
  Classes, OPT, OPS, OPM, OPB, OPP, DebugFrm, SysUtils, LNTi386;

  PROCEDURE Expression(VAR Scaner: TScaner; VAR x: OPT.Nodes);
  PROCEDURE ConstExpression(VAR Scaner: TScaner; VAR x: OPT.Nodes);
  PROCEDURE Qualident(VAR Scaner: TScaner; VAR id: OPT.Objects);
  PROCEDURE Selector(VAR Scaner: TScaner; VAR x: OPT.Nodes);
  PROCEDURE OpCall(VAR op: OPT.Objects; VAR x: OPT.Nodes; y: OPT.Nodes);
  PROCEDURE StandProcCall(VAR Scaner: TScaner; VAR x: OPT.Nodes);
  
IMPLEMENTATION

PROCEDURE Element(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
BEGIN
  y:=NIL;
  Expression(Scaner,x);
  IF sym = _upto THEN BEGIN
    Scaner.Get(sym);
    Expression(Scaner,y);
    IF NOT UndefFlag THEN OPB.SetRange(x, y);
  END ELSE IF NOT UndefFlag THEN
    OPB.SetElem(x);
END;

PROCEDURE Sets(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
BEGIN
  y:=NIL;
  IF sym<>_rbrace THEN BEGIN
    Element(Scaner,x);
    REPEAT
      IF sym = _comma THEN
        Scaner.Get(sym)
      ELSE IF (_lparen <= sym) AND (sym <= _ident) THEN
        err(ORD(_comma))
      ELSE
        BREAK;
      Element(Scaner,y);
      IF NOT UndefFlag THEN OPB.Op(ORD(_plus), x, y);
    UNTIL FALSE;
  END ELSE
    x := OPB.EmptySet();
  Scaner.CheckSym(sym,_rbrace)
END;

PROCEDURE OpCall(VAR op: OPT.Objects; VAR x: OPT.Nodes; y: OPT.Nodes);
VAR
  fpar: OPT.Objects;
  proc, apar, last, retlist, lastret: OPT.Nodes;
BEGIN
  fpar:=NIL;
  proc:=NIL;
  apar:=NIL;
  last:=NIL;
  retlist:=NIL;
  lastret:=NIL;
  IF op<>NIL THEN BEGIN
    proc:=OPB.NewLeaf(op);
    OPB.PrepCall(proc, fpar);
    IF (x.typ.form=sfPointer) AND (op.link.typ.comp=csDynArr) THEN OPB.DeRef(x);
    OPB.Link(apar, last, x);
    IF y<>NIL THEN OPB.Link(apar, last, y);
    IF retlist<>NIL THEN BEGIN
      lastret.link:=apar;
      apar:=retlist
    END;
    OPB.Call(proc, apar, fpar);
    x:=proc;
  END ELSE
    err(137);
END;

//######################################################################

PROCEDURE StandProcCall(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
  m: SHORTINT;
  n: INTEGER;
  flag, flag1: BOOLEAN;
BEGIN

  m := x.obj.adr;
  n := 0;
  flag:=FALSE;
  flag1:=FALSE;
  y:=NIL;
  
  IF ((m = sizefn) OR (m = lenfn)) AND OPB.Vverify THEN BEGIN
    flag := TRUE;
    OPB.verify := NIL;
    OPB.Vverify:=FALSE;
    flag1 := FixPhase;
    FixPhase := TRUE;
  END;

  IF m = awaitfn THEN
    Await(Scaner, x, n)
  ELSE IF sym = _lparen THEN BEGIN
    Scaner.Get(sym);
    IF sym <> _rparen THEN BEGIN
      REPEAT
        IF n = 0 THEN BEGIN
          Expression(Scaner,x);
          (* intercept derefencing of undefined types *)
          IF NOT UndefFlag AND NOT FixPhase AND (m = newfn)
          AND (n = 0) AND (x.typ.BaseTyp = OPT.undftyp) THEN
            UndefFlag := TRUE;
          IF NOT UndefFlag THEN OPB.StPar0(x, m);
          n := 1;
        END ELSE IF n = 1 THEN BEGIN
          Expression(Scaner,y);
          IF NOT UndefFlag THEN OPB.StPar1(x, y, m);
          n := 2
        END ELSE BEGIN
          Expression(Scaner,y);
          IF NOT UndefFlag THEN OPB.StParN(x, y, m, n);
          INC(n);
        END ;
        IF sym = _comma THEN
          Scaner.Get(sym)
        ELSE IF (_lparen <= sym) AND (sym <= _ident) THEN
          err(ORD(_comma))
        ELSE
          BREAK;
      UNTIL FALSE ;
      Scaner.CheckSym(sym,_rparen)
    END ELSE
      Scaner.Get(sym);
  END;

  IF NOT UndefFlag THEN OPB.StFct(x, m, n);
  IF flag THEN BEGIN
    OPB.verify := OwnScope;
    FixPhase := flag1
  END;
  
  IF (level > 0) AND ((m = newfn) OR (m = sysnewfn)) THEN OPT.topScope.link.leaf := FALSE;
END;

PROCEDURE Qualident(VAR Scaner: TScaner; VAR id: OPT.Objects);
VAR
  obj, self: OPT.Objects;
  lev: SHORTINT;
  m: BOOLEAN;
BEGIN
  obj:=NIL;
  OPT.Find(Scaner.Name,obj);

  Scaner.Get(sym);
  IF (sym = _period) AND (obj <> NIL) AND (obj.mode = omMod) THEN BEGIN
    m := TRUE;
    Scaner.Get(sym);
    IF sym = _ident THEN BEGIN
      OPT.FindImport(Scaner.Name,obj, obj);
      Scaner.Get(sym)
    END ELSE BEGIN
      err(ORD(_ident));
      obj := NIL
    END;
  END ELSE
    m := FALSE;

  IF obj = NIL THEN BEGIN
    IF FixPhase OR m THEN BEGIN
      err(0);
      obj := OPT.NewObj();
      obj.mode := omVar;
      obj.typ := OPT.undftyp;
      obj.adr := 0
    END ELSE BEGIN
      UndefFlag := TRUE;
      obj := UndefObj;
    END;
  END ELSE BEGIN
    IF (obj.mode IN [omFld, omTProc]) THEN BEGIN
      self := OPP.GetSelf();
      lev := self.mnolev;
    END ELSE
      lev := obj.mnolev;
    IF (obj.mode IN [omVar, omVarPar, omFld, omTProc]) AND (lev <> level) THEN BEGIN
      obj.leaf := FALSE;
      IF lev > 0 THEN OPB.StaticLink(level-lev);
    END;
  END ;
  id := obj;
  IF (id = UndefObj) AND (OPM.oberon1 IN OPM.options) THEN err(260);
END;

PROCEDURE Selector(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  obj, proc: OPT.Objects;
  y: OPT.Nodes;
  typ: OPT.Structs;
  name: STRING;
BEGIN

  obj:=NIL;
  proc:=NIL;
  y:=NIL;

  IF x.obj.name = 'SELF' THEN BEGIN
    OPT.FindInScope ('@SELF', OPT.topScope, obj);
    IF obj.typ.comp = csRecord THEN	BEGIN
      x := OPB.NewLeaf(obj);
      IF (obj.typ.ptr <> NIL) AND (sym <> _period) THEN BEGIN
        OPB.StPar0 (x, 20);
        OPB.StFct (x, 20, 1);	(* S.ADR *)
        x.typ := obj.typ.ptr;
      END;
    END ELSE IF obj.typ <> OPT.ptrtyp THEN	(* local, but already pointer (i.e. in the body) *)
      x := OPB.NewLeaf (obj);
  END; 
  REPEAT
    IF sym = _lbrak THEN BEGIN
      Scaner.Get(sym);
      REPEAT
        IF (x.typ <> NIL) AND (x.typ.form = sfPointer) THEN OPB.DeRef(x);
        Expression(Scaner,y);
        IF NOT UndefFlag THEN OPB.Index(x, y);
        IF sym = _comma THEN
          Scaner.Get(sym)
        ELSE
          BREAK;
      UNTIL FALSE ;
      Scaner.CheckSym(sym,_rbrak);
    END ELSE IF (sym = _period) THEN BEGIN
      Scaner.Get(sym);
      IF sym = _ident THEN BEGIN
        name := Scaner.name;
        Scaner.Get(sym);
        IF UndefFlag AND NOT FixPhase THEN	(*delayed*)
        ELSE IF x.typ <> NIL THEN BEGIN
          IF x.typ.form = sfPointer THEN BEGIN
            OPT.MarkObj(x.typ.strobj);
            OPB.DeRef(x)
          END;
          IF x.typ.comp = csRecord THEN BEGIN
            OPT.FindField(name, x.typ, obj, TRUE);
            IF ((obj = NIL) OR (obj.mode < 0)) AND NOT FixPhase THEN
              UndefFlag := TRUE
            ELSE
              OPB.Field(x, obj);
          END ELSE IF (x.typ = OPT.undftyp) AND NOT FixPhase THEN
            UndefFlag := TRUE
          ELSE
            err(53);
        END ELSE
          err(52);
      END ELSE
        err(ORD(_ident));
    END ELSE IF sym = _arrow THEN BEGIN
      Scaner.Get(sym);
      IF UndefFlag AND NOT FixPhase THEN
      ELSE IF (x.obj<>NIL) AND (x.obj.mode = omTProc) THEN BEGIN
        y := x.left;
        IF y.clas = Nderef THEN y := y.left;	(* y = record variable *)
        IF y.obj <> NIL THEN BEGIN
          proc := OPT.topScope;	(* find innermost scope which owner is a TProc *)
          WHILE (proc.link <> NIL) AND (proc.link.mode <> omTProc) DO proc := proc.left;
          IF (proc.link = NIL) OR (proc.link.link <> y.obj) THEN err(75);
          typ := y.obj.typ;
          IF typ.form = sfPointer THEN typ := typ.BaseTyp;
          OPT.FindField (x.obj.name, typ.BaseTyp, proc, TRUE);
          IF proc <> NIL THEN
            x.subcl := super
          ELSE
            err(74);
        END ELSE
          err(75);
      END ELSE IF x.typ.form <> sfPointer THEN
        err(84)
      ELSE
        OPB.DeRef(x);
    END ELSE IF (sym = _lparen) AND UndefFlag AND NOT FixPhase THEN	BEGIN(*type cast or proc call, here is Oberon ambigous*)
      Scaner.Get(sym);
      UndefFlag := FALSE;
      IF sym <> _rparen THEN BEGIN
        Expression(Scaner,x);
        WHILE sym = _comma DO BEGIN
          Scaner.Get(sym);
          UndefFlag := FALSE;
          Expression(Scaner,x)
        END
      END;
      Scaner.CheckSym(sym,_rparen);
      UndefFlag := TRUE
    END ELSE IF (sym = _lparen) AND (x.clas < Nconst) AND (x.typ <> NIL)
    AND (x.typ.form <> sfProcTyp) AND ((x.obj = NIL) OR (x.obj.mode <> omTProc)) THEN BEGIN
      Scaner.Get(sym);
      IF sym = _ident THEN BEGIN
        Qualident(Scaner,obj);
        IF obj.mode = omTyp THEN
          OPB.TypTest(x, obj, TRUE)
        ELSE IF NOT UndefFlag THEN
          err(52)
        ELSE IF sym = _period THEN BEGIN	(* M.T -> Module not defined *)
          err (0);
          Scaner.Get (sym);
          Scaner.CheckSym(sym,_ident);
        END;
      END ELSE
        err(ORD(_ident));
      Scaner.CheckSym(sym,_rparen);
    END ELSE
      BREAK;
  UNTIL FALSE;
END;

PROCEDURE Factor (VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  fpar, id: OPT.Objects;
  apar, y: OPT.Nodes;
  name: STRING;
BEGIN
  IF sym < _lparen THEN BEGIN
    err(13);
    REPEAT Scaner.Get(sym) UNTIL sym >= _lparen;
  END ;

  id:=NIL;
  fpar:=NIL;
  apar:=NIL;
  y:=NIL;

  IF sym = _ident THEN Qualident(Scaner,id);

  IF (id<>NIL) AND (id.prio<>127) THEN BEGIN	(*found object is not an operator *)
    x := OPB.NewLeaf(id);
    Selector(Scaner,x);
    IF (x.clas = Nproc) AND (x.obj.mode = omSProc) THEN BEGIN
      IF (x.obj.name = 'SIZE') AND NOT FixPhase THEN UndefFlag := TRUE;
      StandProcCall(Scaner,x)	(* x may be NIL *)
    END ELSE IF sym = _lparen THEN BEGIN
        UndefFlag := UndefFlag OR (x.typ = NIL);
        Scaner.Get(sym);
        IF UndefFlag THEN
          ActualParameters(Scaner,apar, fpar, x)
        ELSE BEGIN
          OPB.PrepCall(x, fpar);
          ActualParameters(Scaner,apar, fpar, x);
          IF (x.clas = Nproc) AND (x.obj.mode = omCProc) THEN
            InlineProc (x, apar, fpar)
          ELSE
            OPB.Call(x, apar, fpar);
        END;
        Scaner.CheckSym(sym,_rparen);
        IF level > 0 THEN OPT.topScope.link.leaf := FALSE;
    END ELSE IF  (x.clas = Nfield) AND (x.obj.mode = omTProc)
    AND (x.obj.typ <> OPT.notyp) THEN
      err(ORD(_lparen));
  END ELSE IF (id<>NIL) AND (id.prio=127) THEN BEGIN(* imported operator/ *)
    Scaner.Get(sym);
    Factor(Scaner,x);
    OPP.Resolve(id, name, x, y);
    OpCall(id, x, NIL)
  END ELSE IF sym = _number THEN BEGIN
    CASE Scaner.numtyp OF
      _char     : BEGIN x := OPB.NewIntConst(Scaner.intval); x.typ := OPT.chartyp; END;
      _integer  : BEGIN x := OPB.NewIntConst(Scaner.intval);                        END;
      _real     : BEGIN x := OPB.NewRealConst(Scaner.realval, OPT.realtyp);         END;
      _longreal : BEGIN x := OPB.NewRealConst(Scaner.lrlval, OPT.lrltyp);           END;
    END ;
    Scaner.Get(sym)
  END ELSE IF sym = _true THEN BEGIN
    x := OPB.BoolConst(1);
    Scaner.Get(sym);	(* 1 is a compiler internal representation only *)
  END ELSE IF sym = _false THEN BEGIN
    x := OPB.BoolConst(0);
    Scaner.Get(sym);	(* 0 is a compiler internal representation only *)
  END ELSE IF sym = _string THEN BEGIN
    x := OPB.NewString(Scaner.str, Scaner.intval);
    Scaner.Get(sym);
  END ELSE IF sym = _nil THEN BEGIN
    x := OPB.FNNil();
    Scaner.Get(sym);
  END ELSE IF sym = _lparen THEN BEGIN
    Scaner.Get(sym);
    Expression(Scaner,x);
    Scaner.CheckSym(sym,_rparen);
  END ELSE IF sym = _lbrak THEN BEGIN
    Scaner.Get(sym);
    err(ORD(_lparen));
    Expression(Scaner,x);
    Scaner.CheckSym(sym,_rparen)
  END ELSE IF sym = _lbrace THEN BEGIN
    Scaner.Get(sym);
    Sets(Scaner,x);
  END ELSE IF (sym = _not)  THEN BEGIN
    name:=Scaner.name;
    Scaner.Get(sym);
    y:=NIL;
    id:=NIL;
    Factor(Scaner,x);
    IF NOT UndefFlag THEN	BEGIN(*test*)
      OPP.Resolve(id, name, x, y);
      IF id=NIL THEN
        OPB.MOp(vnot, x)
      ELSE
        OpCall(id, x, y);
    END;
  END ELSE BEGIN
    err(13);
    Scaner.Get(sym);
    x := NIL;
  END ;
  IF x = NIL THEN BEGIN
    x := OPB.NewIntConst(1);
    x.typ := OPT.undftyp
  END;
END;

PROCEDURE Term(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
  mulop: SHORTINT;
  name: STRING;
  op: OPT.Objects;
  b: BOOLEAN;
BEGIN
  y:=NIL;
  op:=NIL;
  b := UndefFlag;
  UndefFlag := FALSE;
  Factor(Scaner,x);
  WHILE (_times <= sym) AND (sym <= _and) DO BEGIN
    op:=NIL;
    mulop := ORD(sym);
    name:=Scaner.name;
    Scaner.Get(sym);
    Factor(Scaner,y);
    IF NOT UndefFlag THEN BEGIN
      OPP.Resolve(op, name, x, y);
      IF op=NIL THEN
        OPB.Op(mulop, x, y)
      ELSE
        OpCall(op, x, y);
    END;
  END;
  UndefFlag := UndefFlag OR b;
END;

PROCEDURE SimpleExpression(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
  addop : SHORTINT;
  name: STRING;
  op: OPT.Objects;
  b: BOOLEAN;
BEGIN
  b := UndefFlag;
  UndefFlag := FALSE;
  y:=NIL;
  IF (sym=_plus) OR (sym=_minus) THEN BEGIN
    op:=NIL;
    addop := ORD(sym);
    name:=Scaner.name;
    Scaner.Get(sym);
    Term(Scaner,x);
    y:=NIL;
    IF NOT UndefFlag THEN BEGIN
      OPP.Resolve(op, name, x, y);
      IF op=NIL THEN
        OPB.MOp(addop, x)
      ELSE
        OpCall(op, x, y);
    END;
  END ELSE
    Term(Scaner,x);

  WHILE (_plus <= sym) AND (sym <= _or) DO BEGIN
    op:=NIL;
    addop := ORD(sym);
    name:=Scaner.name;
    Scaner.Get(sym);
    Term(Scaner,y);
    IF NOT UndefFlag THEN BEGIN
      OPP.Resolve(op, name, x, y);
      IF op=NIL THEN
        OPB.Op(addop, x, y)
      ELSE
        OpCall(op, x, y);
    END;
  END;
  UndefFlag := UndefFlag OR b;
END;

PROCEDURE Expression(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  y: OPT.Nodes;
  obj: OPT.Objects;
  relation: SHORTINT;
  name: STRING;
BEGIN
  y:=NIL;
  SimpleExpression(Scaner,x);
  IF (_eql <= sym) AND (sym <= _geq) THEN BEGIN
    obj:=NIL;
    relation := ORD(sym);
    name:=Scaner.name;
    Scaner.Get(sym);
    SimpleExpression(Scaner,y);
    IF NOT UndefFlag THEN BEGIN
      OPP.Resolve(obj, name, x, y);
      IF obj=NIL THEN
        OPB.Op(relation, x, y)
      ELSE
        OpCall(obj, x, y);
    END
  END ELSE IF sym = _in THEN BEGIN
    obj:=NIL;
    name:=Scaner.name;
    Scaner.Get(sym);
    SimpleExpression(Scaner,y);
    IF NOT UndefFlag THEN BEGIN
      OPP.Resolve(obj, name, x, y);
      IF obj=NIL THEN
        OPB.FNIn(x, y)
      ELSE
        OpCall(obj, x, y);
    END;
  END ELSE IF sym = _is THEN BEGIN
    Scaner.Get(sym);
    IF sym = _ident THEN BEGIN
      Qualident(Scaner,obj);
      IF NOT UndefFlag THEN BEGIN
        IF obj.mode = omTyp THEN
          OPB.TypTest(x, obj, FALSE)
        ELSE
          err(52);
      END ELSE BEGIN
        IF sym = _period THEN BEGIN
          err(0);
          Scaner.Get(sym);
          Scaner.CheckSym(sym,_ident);
        END;
      END;
    END ELSE
      err(ORD(_ident));
  END;
END;

PROCEDURE ConstExpression(VAR Scaner: TScaner; VAR x: OPT.Nodes);
VAR
  tmp: BOOLEAN;
BEGIN
  tmp := FixPhase;
  FixPhase := TRUE;	(*no forward references to constants allowed*)
  Expression(Scaner,x);
  IF x.clas <> Nconst THEN BEGIN
    err(50);
    x := OPB.NewIntConst(1)
  END;
  FixPhase := tmp
END;

END.
