UNIT OBRParser;

INTERFACE

USES
  Classes, SysUtils,  STreeView, ComCtrls, OBRScaner, OPM;

  PROCEDURE OBRManage(N: String; TreeView: TSTreeView; Stream: TStringList);
  PROCEDURE AddTemplate(Lines: TStringList; Name:STRING);
  
IMPLEMENTATION

PROCEDURE AddTemplate(Lines: TStringList; Name:STRING);
BEGIN
  Lines.BeginUpdate;
  if Lines.Count>0 then
    Lines.Text:='MODULE '+copy(Name,1,pos('.',Name)-1)+';'
  else
    Lines.Add('MODULE '+copy(Name,1,pos('.',Name)-1)+';');
  Lines.Add('');
  Lines.Add('BEGIN');
  Lines.Add('');
  Lines.Add('END '+copy(Name,1,pos('.',Name)-1)+'.');
  Lines.EndUpdate;
END;

//#######################################################################

PROCEDURE OBRManage(N: String; TreeView: TSTreeView; Stream: TStringList);
VAR
  Scaner    : OBRScaner.TScaner;
  Tok       : OBRScaner.TToken;
  tmpStream : TMemoryStream;
  Name      : STRING;
  Root,Node,NConst,NImport,NProc,NVar: TTreeNode;
BEGIN
  tmpStream:= TMemoryStream.Create;
  tmpStream.Write(Stream.Text[1],Length(Stream.Text));
  Scaner:= TScaner.Create(tmpStream);
  Scaner.Get(Tok);

  if not TreeView.Visible then TreeView.Visible:=true;
  TreeView.Items.BeginUpdate;
  TreeView.Items.Clear;

  Root:=TreeView.Items.AddChildObject(NIL,N,NIL);
  NImport := TreeView.Items.AddChildObject(Root,'IMPORT',NIL);
  NImport.ImageIndex:=39;
  NConst  := TreeView.Items.AddChildObject(Root,'CONSTANTS',NIL);
  NConst.ImageIndex:=39;
  NVar    := TreeView.Items.AddChildObject(Root,'VARIABLES',NIL);
  NVar.ImageIndex:=39;
  NProc   := TreeView.Items.AddChildObject(Root,'PROCEDURES',NIL);
  NProc.ImageIndex:=39;

  TSTreeNode(Root).Main:=false;
  TSTreeNode(NConst).Main:=false;
  TSTreeNode(NImport).Main:=false;
  TSTreeNode(NProc).Main:=false;
  TSTreeNode(NVar).Main:=false;

  WHILE Tok<>_eof DO BEGIN
    Name:='';

    CASE Tok OF
      _import:
              BEGIN
                Scaner.Get(Tok);
                REPEAT
                  IF Tok = _ident THEN BEGIN
                    Name:=Scaner.name;
                    Scaner.Get(Tok);
                    IF Tok = _becomes THEN BEGIN
                      Scaner.Get(Tok);
                      IF Tok = _ident THEN BEGIN
                        Name:=Scaner.name;
                        Scaner.Get(Tok);
                      END;
                    END;
                    IF Name='SYSTEM' THEN ELSE Name:=Name+OPM.moduleext;
                    Node:=TreeView.Items.AddChildObject(NImport,Name,NIL);
                    TSTreeNode(Node).Main:=false;
                    Node.ImageIndex:=40;
                  END ELSE
                    BREAK;
                  IF Tok = _comma THEN
                    Scaner.Get(Tok)
                  ELSE
                    BREAK; 
                UNTIL FALSE;
              END ;
    ELSE
      Scaner.Get(Tok);
    END;
  END;

  Root.Expand(false);
  NConst.Collapse(true);
  NImport.Collapse(true);
  NProc.Collapse(true);
  NVar.Collapse(true);
  TreeView.Items.EndUpdate;

  Scaner.Free;
  tmpStream.Free;
END;

END.
